* 8/5/17 Relocate the RAM data away from 0xF0000 to below 0x20000.  This is because
*  RAM disk for CP/M68k is from 0xC0000 to 0xFFFFF.  It is now at 0x10000, (same as 0x210000)
* 12/15/16 Add "xt" command to set real time clock.  "xt"" shows time, "xt yymmddhhmmss"
* set time and transmit time information over Xbee, if present.
* 12/14/16 write "rts" in $2f3010 during initialization.  In foreground loop execute
* bsr $2f3010.  This allow an user program to load into $2f3010 and included in the 
* foreground execution.
* 12/9/16 change the way LCD display is detected:  use d3 bit of $300060 to check
* LCD display.  That bit is nominally pulled up with 10K resistor.  Ground it for LCD display
* Design interactive session for mm and mr commands so it is called from the top
* a state, sInteractive, is used to indicate whether it is mm or mr interactive session
* 12/5/16 going to version 1.1x to reflect the approach of keeping core AMbug fuctions 
* apart from applications such as LCD display and Xbee.
* LCD display will be a separate task with its variables kept in 2F1000 while Xbee's task
* variables are in 2F2000.
* 12/2/16 Have 8 pages for display using toggle switches.
* Page 0 is home page, default (such as idle count)
* page 1-7 are user definable
* Each page has a table defines:
*   pLnxLCD (x=1 to 4) that points to variable to be printed
*   LnxLabel (x=1 to 4) print label first before the variable. Value lesser than 0x20
*   is the terminating character which indicates the end of label string and starting 
*   print variables.  Terminating character also define how variable is to be printed,
*   0=ASCII, 1=Hex, 2=decimal...
* 11/30/16 Each line of LCD display can be at different location.  pLn1LCD points to 
* first line, pLn2LCD second line, etc.  The msb byte of each pointer defines how the
* data is to be displayed: 0x0 means as is (ASCII), 0x1 means hex.  A 80-byte buffer
* is filled data to be displayed which is refreshed at the beginning of display.
* LCD display can be dynamically detected while program is running
* 11/28/16 v1.04, think in term of task oriented foreground loop.  Calling idle, command 
*  processing, LCD display driver (where applicable)
* 11/7/16 bug fixed in prog010b
* 4/4/15 add diagnostics to understand why in breakpoint mode, a carriage return does not
*   cause a trace instruction to be executed like other boards
* 3/30/15, fork from AMbugr v0.91
* with updated S record loader, should be able to org to $400 with exception vector at $0
* ADC MPU bug for RAM
* desirable commands for near-term development:
* cp copy source to destination
* du dump memory content
* as assemble
* ds disassemble
* up zmodem upload
* dn zmodem download
* 4/2 v1.01, modify 'sw' so if loc 0x0 is modifiable, don't switch
* 4/4 v1.02, 'Z' command will now clear a 16K block RAM starting $2F8000

BAR	equ $0F2 *Base Address Register
SCR	equ $0F4 *System Control Register
CKCR	equ $0F6 *Clock Control Register
base	equ $FFF000
GIMR	equ base+$812 *Global Interrupt Mode Register
IPR	equ base+$814 *Interrupt Pending Register
IMR	equ base+$816 *Interrupt Mask Register
ISR	equ base+$818 *In-Service Register
SIMODE	equ base+$8B4 *Serial Interface Mode Register
SCON1	equ base+$882 *SCC1 Configuration Register
SCM1	equ base+$884 *SCC1 Mode Register
SCCE1	equ base+$888 *SCC1 Event Register
SCCM1	equ base+$88A *SCC1 Mask Register
ENSCC	equ $0C *ENR and ENT bits in SCM
TMR1	equ base+$840	* timer1 mode reg
TRR1	equ base+$842	* timer1 reference reg
TCN1	equ base+$846	* timer1 counter
TER1	equ base+$849	* timer1 event reg
PACNT	equ base+$81E	* port A control register
PADDR	equ base+$820	* port A Data Direction Reg
PADAT	equ base+$822	* port A Data Reg
PBCNT	equ base+$824	* port B control reg
PBDDR	equ base+$826	* port B Data Direction Reg
PBDAT	equ base+$828	* port B Data Reg

DUART	equ $300020	* base address of 68692 DUART
MRA	equ $300020	* mode reg A
SRA	equ $300022	* status A (read)
CSRA	equ $300022	* clock select reg (write)
CRA	equ $300024	* command register (write only)
RHRA	equ $300026	* Rx Hold reg A (read)
THRA	equ $300026	* Tx Holding reg (write)
IPCR	equ $300028	* Input port change reg (read)
ACR	equ $300028	* Aux control reg (write)
ISRD	equ $30002A	* interrupt status reg (read)
IMRD	equ $30002A	* interrupt mask reg (write)			
CTU	equ $30002C	* Counter/timer upper (read)
CTL	equ $30002E	* counter/timer lower (read)
MR1B	equ $300030	* mode reg B
SRB	equ $300032	* status reg B
RHRB	equ $300036	* Rx holding reg B
IVRD	equ $300038	* interrupt vector reg
PortA82C55 equ $300001     * 82C55 port A
PortB82C55 equ $300003     * 82C55 port B
PortC82C55 equ $300005     * 82C55 port C
Ctrl82C55  equ $300007     * 82C55 control register

True	equ 0
False	equ 1
Error	equ $ff

	org	$210000		* 0x210000-0x215000 of RAM is for stack and global variables
				
ROMver	ds.l 1			* this is 1st variable of a task descriptor block
wallclock ds.l 1		* global wall clock
downtimer ds.w 2		* this is always the 3rd variable of a TDB
amrsvp	ds.l 1			* reserve fix long word for future
EASy7seg ds.w 8           * base address of EASy68K 7-segment display
EASyLED  ds.w 1            * address of EASy68K display's LED
EASytoggle ds.w 1          * address of EASy68K hardware toggle switches
EASypush ds.w 1            * address of EASy68K hardware push switches
savd0	ds.l 1			* allocate for 68302 registers
savd1	ds.l 1
savd2	ds.l 1
savd3	ds.l 1
savd4	ds.l 1
savd5	ds.l 1
savd6	ds.l 1
savd7	ds.l 1
sava0	ds.l 1
sava1	ds.l 1
sava2	ds.l 1
sava3	ds.l 1
sava4	ds.l 1
sava5	ds.l 1
sava6	ds.l 1
savsp	ds.l 1
savpc	ds.l 1
	
cUErr	ds.w 1
fWval	ds.b 1			* write flag
fSerr	ds.b 1			* S record error
pStr	ds.l 1			* string pointer for DUARTisr
bAnswer	ds.l 5			* 16 bytes of response buffer, byte order:
			* LF, CR, A, A, A, A, A, A, ':', 
			* D, D, D, D, LF, CR, '>', ' ', 0
bCmdline ds.l 5		* command line, handle up to 20 characters
pCmdln	ds.l 1		* pointer into the command line buffer
cCmd	ds.b 1		* count number of bytes in command buffer
fDoCmd	ds.b 1		* flag for command ready to execute	
cCmdparam ds.b 1	* number of command parameters
fCmdDone ds.b 1		* flag for command in progress (0) or done (1)
cmdparam ds.l 4		* command parameters
RegASCII ds.b 10		* ASCII value of a register, null terminated
am3reserve ds.b 2	* reserve
cntIdle	ds.l 1		* idle loop counter
maxIdle	ds.l 1		* Idle loop count for this time period
nullchar ds.b 2		* string terminator, two characters, 
			* one will be modified for mr command use
fTxDone	ds.b 1		* flag for ISR finishs transmitting string
fbpverbose ds.b 1	* verbose flag for breakpoint
bkptaddr ds.l 1		* address where illegal instruction is inserted
bkptinstr ds.w 1	* instruction swapped out for breakpoint
fdobkpt	ds.b 1		* indicating whether breakpoint is in progress or not
fSerrAll ds.b 1		* reserve byte
cTrace	ds.w 1		* number of trace to perform
seconds	ds.b 1		* time register (seconds) in RTC72423
sInteractive ds.b 1	* Interactive session state, 0=none, 1=mm cmd, 2=mr cmd, 3=xs, 4=xd
startaddr ds.l 1	* starting address for the S record file load
idlecnt	ds.l 1		* idle loop count, Range of its value decides LED color
mmaddress ds.l 1	* address value from mm command saved for interactive session
rtctime	ds.b 20		* Last read value of the real time clock, rtc72423, in ascii
rtctimebcd ds.b 6	* real time clock value in packed bcd, yymmddhhmmss
exitCode ds.b 1		** error code for command execution.  0=normal, 1=error
fEASyTEcho ds.b 1         * echo flag for EASy trap 15 task 12 echo is default to on, 
                           * 0=echo off 
fEASyTCRLF ds.b 1          * flag to signify adding CR LF to output string
c7segScan ds.b 1           * keep track of which 7-segment to display
EASyreserve ds.b 2         * reserved
	org	$0
* reset vector
	dc.l $210FFC      * stack is right below CP/M 68K
	dc.l AMbug	* start address of AMbug
	dc.l buserr	* BERR handler
	dc.l addrerr	* address error handler
	dc.l breakpt	* illegal instruction used as breakpoint
	dcb.l 4,unknown
	dc.l trace	* trace handling
	dcb.l 37,unknown	* set the rest to unknown which just
					* blink red/green light rapidly
         dc.l EASyTrap     * trap 15 implementing EASy trap services	
         dcb.l 12,unknown

	org $100		* skip over $F0-$FF, system area for 68302
	dcb.l 65,unknown
*	dc.l unknown	* No. $80, Error

	dc.l DUARTisr	* No. $81, service DUART connected to PB8

*	dc.l unknown	* No. $82, SMC2
*	dc.l unknown	* No. $83, SMC1
*	dc.l unknown	* No. $84, Timer3
*	dc.l unknown	* No. $85, SCP
*	dc.l unknown	* No. $86, Timer2
*	dc.l unknown	* No. $87, PB9
	dcb.l 7,unknown
*	dc.l Xbeeisr	* No. $88, SCC3
	dc.l timer1isr	* No. $89, service the 10ms OS timer

*	dc.l unknown	* No. $8A, SCC2
*	dc.l unknown	* No. $8B, IDMA
*	dc.l unknown	* No. $8C, SDMA BERR
*	dc.l unknown	* No. $8D, SCC1
*	dc.l unknown	* No. $8E, PB10
*	dc.l unknown	* No. $8F, PB11
*	dc.l unknown	* No. $90
*	dc.l unknown	* No. $91, Extern
*	dc.l unknown	* No. $92
*	dc.l unknown	* No. $93
*	dc.l unknown	* No. $94
*	dc.l unknown	* No. $95
*	dc.l unknown	* No. $96, Extern
*	dc.l unknown	* No. $97, Extern
	dcb.l 118,unknown	* rest are unknown

	org $400		* not necessary, but just in case...
AMbug:
	move.w #$2700,sr	* mask off interrupts
	move.w #$0FFF,BAR	* BAR points to 0xFFFxxx
	lea $210FFC,sp	* initialize stack to below CP/M68K
***
* RAM and boot flash are switched in this board
* initialize ORx first before BRx
*	move.w #$3C00,$FFF832 	* OR0, 1 wait, R/W, 2048K space
*	move.w #$3800,$FFF832 	* OR0, 1 wait, R/W, 4096K space, aliased
*	move.w #$C001,$FFF830 	* BR0, $0, CS0 RAM
*	move.w #$3F80,$FFF836	* OR1, 1 wait, R/W, 256K space
*	move.w #$401,$FFF834	* BR1, $200000, CS1, Boot flash
*	move.w #$CC01,$FFF834	* BR1, $600000, CS1, Boot flash
**********AMbugb******************
	move.w #$3F80,$FFF832 	* OR0, 1 wait, R/W, 256K space
	move.w #$C001,$FFF830 	* BR0, $0, CS0 Flash
	move.w #$1800,$FFF836	* OR1, 0 wait, R/W, 4096K space, aliased
	move.w #$401,$FFF834	* BR1, $200000, CS1, RAM
**********AMbugb******************
	move.w #$3E00,$FFF83A 	* OR2, 1 wait, R/W, 1024K space
	move.w #$801,$FFF838 	* BR2, $400000, CS2
	move.w #$3E00,$FFF83E 	* OR3, 1 wait, R/W, 1024K space
	move.w #$A01,$FFF83C 	* BR3, $500000, CS3
restart:
	reset
	bra entry

* User command dispatch tables
commands:
	
	dc.l do_dm-exec_cmd	* display memory
	dc.l do_dr-exec_cmd	* display register
	dc.l do_mm-exec_cmd	* modify memory
	dc.l do_mr-exec_cmd	* modify register
	dc.l do_go-exec_cmd	* go
	dc.l do_bp-exec_cmd	* breakpoint
	dc.l do_sw-exec_cmd	* switch RAM/ROM
	dc.l do_help-exec_cmd	* help message
	dc.l do_du-exec_cmd	* dump memory content command

* corresponding mnemonic for the user command table
mnemonictbl:
	dc.w 'dm'
	dc.w 'dr'
	dc.w 'mm'
	dc.w 'mr'
	dc.w 'go'
	dc.w 'bp'
	dc.w 'sw'
	dc.w 'he'
	dc.w 'du'
	dc.w $0
hex7segtbl:         
* hex to 7-segment lookup table
         dc.b  $C0         *digit 0
         dc.b  $F9         *digit 1
         dc.b  $A4         *digit 2
         dc.b  $B0         *digit 3
         dc.b  $99         *digit 4
         dc.b  $92         *digit 5
         dc.b  $82         *digit 6
         dc.b  $F8         *digit 7
         dc.b  $80         *digit 8
         dc.b  $90         *digit 9
         dc.b  $88         *digit A
         dc.b  $83         *digit B
         dc.b  $C6         *digit C
         dc.b  $A1         *digit D
         dc.b  $86         *digit E
         dc.b  $8E         *digit F
segDsplytbl:
* look up which 7-segment display to turn on
         dc.w     $8080    * turn on the most significant 7-seg digit
         dc.w     $4040
         dc.w     $2020
         dc.w     $1010
         dc.w     $0808
         dc.w     $0404
         dc.w     $0202
         dc.w     $0101    * turns on the least significant 7-seg digit   
         org (*+1)&-2      * force word alignment	
entry:
	move.w #$80,GIMR	* normal mode, vector no 80-9F
	move.w #0,IMR		* mask off all interrupts
	move.w #$FFFF,IPR	* clear all pending interrupts
	move.w #$FFFF,ISR	* clear all in-service bits
	move.w #$0,PBCNT	* enable TIN1 as PB3
	move.w #$0408,PBDDR	* PB10 and PB3 are outputs
	move.w #$0408,PBDAT	* assert PB3 and PB10 output, light should be green	
	lea signon(pc),a0	* relocatable code
	move.l a0,pStr		* pStr points to the signon message


	move.l #$1e1e1e1e,$210ffc	* mark memory beyond top of the stack as a
				* way to check stack underflow		
	clr.l d1		* clear all data and address registers, except a5
	clr.l d2
	clr.l d3
	clr.l d4
	clr.l d5
	clr.l d6
	clr.l d7
	lea $0,a1
	lea $0,a2
	lea $0,a3
	lea $0,a4
	lea $0,a6
	move.w #3,d0		* clear fixed task variables in 4 task areas
	lea $210000,a0
taskvars:
	clr.l (a0)+		* version 
	clr.l (a0)+		* wall clock
	clr.l (a0)		* count down timers
	add.l #$ff8,a0		* next task descriptor block
	dbra d0,taskvars
	move.l #$30323033,ROMver	* version number of active tasks are in $2Fx000
				* need a better way of doing this
* initialize timer1 which will serve as operating system 10ms timer
	move.w #$f1b,TMR1	* enable timer, use master clock, restart, enable 
				* interrupt, capture disabled, prescaler of 16
	move.w #10000,TRR1	* equivalent to 10mS with 16MHz master clock
	clr.w TCN1		* clear timer counter
	clr.l bkptaddr		* no breakpoint
	clr.b fdobkpt
	move.b #1,fbpverbose	* the verbose flag for breakpoint
	bsr iBuffer
         bsr enableNextCmd          * get ready for new command
	clr.b fCmdDone		** 
	clr.b sInteractive	* set interactive session state to none
	clr.w nullchar		* null terminator for the register string
	move.b #1,fTxDone          * mark transmitter ready
	bsr iDUART                 * initialize DUART
	clr.b fSerr		* clear s record error flag
	move.b #' ',RegASCII+8	* put a space character at the end of register string
	clr.b RegASCII+9	* null terminate the register string
	clr.b fSerrAll		* clear cumulated S record error flag
	move.l #300000,idlecnt	* init idle counter value to green
	move.b #$4,$30005F	* this is the reset register of RTC72423.  run in 24 hr mode
	move.b $300041,seconds	* read the time register
	and.b #$f,seconds	* only the low nibble contains valid data
	clr.l cntIdle		* reset idle loop counter
	move.b #1,fEASyTEcho      * echo is default to on
	bsr iEASyDisplay         * initialize the 82C55 driving the EASy68k display
	clr.b c7segScan            * index for which 7-seg display to turn on
	move.w #$4e75,$213010	* "rts" instruction in task 4 entry point
	btst.b #3,$300061	* bit 3 is nominally pullup via 10K resistor
				* ground it to indicate LCD display presence
	bne mpuinit1
	bsr initLCD		* initialize 4x20 LCD display		
mpuinit1:
	move.w #$202,IMR	* enable DUART interrupt (PB8 on 68302) and timer1
	move.w #5,CRA		* enable transmit and receive
	btst.b #0,$300060	* if Xbee present, enable SCC3 interrupt
	bne mpuinit2
	or.w #$100,IMR		* enable SCC3 interrupt
mpuinit2:
	move.w #$2000,SR	* lower interrupt level
	
*         lea signon(pc),a1          **E sign on message
*         move.b #14,d0             **E send message without CR LF
*         trap #15
	lea signon(pc),a0	* relocatable code
	move.l a0,pStr		* pStr points to the signon message
	move.w #3,IMRD		* enable Chan A TxRDY/RxRdy interrupts

******************************************
* foreground loop
fore:
	bsr idleled		* idle routine changing LED color
	bsr EASyDisplay            * EASy68k hardware display
	bsr AMbugCmd		* processing console command
	btst.b #3,$300061	* bit 3 is nominally pullup via 10K resistor
				* ground it to indicate LCD display presence
	bne fore7
	bsr LCDstart		* update 4x20LCD display (if installed)
fore7:
	jsr $213010		* task 4 entry point, rts if no program there
				* don't use bsr, it is PC-relative 
				
* counting the number of idle loop per second gives a good idea of CPU utilization
* another way is to check the min/max value in a second.  Save that project for another time
	move.b $300041,d0	* read the time register
	and.b #$F,d0		* only the low nibble is valid
	cmp.b seconds,d0	* has the second rolls over?
	beq fore9
	move.l cntIdle,maxIdle	* save the idle value for this time period
	clr.l cntIdle
	move.b d0,seconds	* update with new value
fore9:
	add.l #1,cntIdle	* increment idle loop counter
	bra fore
******************************************
idleinit:
	move.l #100000,idlecnt
	move.w #$408,PBDAT	* green
idleled:
	sub.l #2,idlecnt
	cmp.l #100000,idlecnt	* force d5 between 0-100000
	bgt idleinit
	cmp.l #0,idlecnt
	ble idleinit	
	cmp.l #70000,idlecnt
	bne idle1
	move.w #$0400,PBDAT	* amber
idle1:
	cmp.l #40000,idlecnt
	bne idle9
	move.w #0,PBDAT		* red
idle9:
	rts
EASyDisplay:
* Only one 7-segment digit can be displayed, so the routine repeatly scan through all digits
* variable c7segScan controls which digit will be displayed
         lea EASy7seg,a1            * get base address of the 7-seg display
         clr.l d1                   * make sure register is all zero
         move.b c7segScan,d1        * get the scan variable
* display LEDs in this turn
         cmp.b #16,d1               **X drive LED if index is 16
         blt EASyDisplay2           **X 7 segment display if index not 16
* at the top of the scan index (index=16), read toggle & push switch values, drive discrete 
* LEDs, read toggle switches & push button switches 
         move.b #$E,PortC82C55      * 7seg driver off, toggle sw off, push sw off, LED off
         move.b #$82,Ctrl82C55      * turn port B to input
         move.b #$C,PortC82C55      * 7seg driver off, toggle sw on, push sw off, LED off
         move.b PortB82C55,EASytoggle       * read and store toggle switch position
         move.b #$A,PortC82C55      * 7seg driver off, toggle sw off, push sw on, LED off
         move.b PortB82C55,EASypush * read and store push switch position
         move.b #$E,PortC82C55      * 7seg driver off, toggle sw off, push sw off, LED off
         move.b #$80,Ctrl82C55         * set all 82C55 discretes to outputs
         move.b #6,PortC82C55          * turns off switch inputs, turn on display driver,
                                    * turns off LEDs
         move.b #0,PortA82C55       * turn off all 7-seg display
         move.b EASyLED,d0          * EASyLED contains which LEDs to turn on
         not.b d0                   * need to invert value due to hardware implementation
         move.b d0,PortB82C55       * write out LED value
         move.b #7,PortC82C55       * 7 seg driver on, toggle sw off, push sw off, LED on
         clr.b c7segScan            * reset scan index
         bra EASyDisplay9         
EASyDisplay2         
         move.b (a1,d1),d0          * read the value of the 7-seg register to be displayed
         not.b d0                   * need to invert value due to hardware implementation
         move.b #0,PortA82C55          * turn off all display before writing value
         move.b #6,PortC82C55       * 7 seg driver on, toggle sw off, push sw off, LED off
         move.b d0,PortB82C55          * put it to display data register
         lea segDsplytbl(pc),a2         * look up table for which 7-seg display to turn on
         move.b (a2,d1),PortA82C55     * turns on the indexed display
         add.b #2,c7segScan         * display next digit


EASyDisplay9:
         rts
AMbugCmd:
* when in interactive session, look for difference sources of inputs depending on the session
* session #1, looks for fDoCmd ready (keyboard inputs)
* interactive session of mm command	
	tst.b sInteractive
	beq doCmd
	movem.l a0-a5/d0-d7,-(sp)	** save registers 
	cmp.b #1,sInteractive
	bne interact9
	tst.b fDoCmd
	beq dodo9		**
**	beq dodo9n
**	movem.l a0-a5/d0-d7,-(sp)	* save registers 
	bsr mminteractive	* mm command interactive session
**	bra dodo8		
	bra dodo9		**

	
interact9
	clr.b sInteractive		* error condition, 
* should print error message 
**	bra badcommand
	bra dodo9		**
	
	
doCmd:	
	tst.b fDoCmd		* Is a keyboard command ready for execution?
**	beq dodo9n	
	beq doPrompt		** check if prompt needs to be output
cmdtodo:
	movem.l a0-a5/d0-d7,-(sp)	* save registers 

	cmp.b #2,cCmd		* need at least 2 char in command line before
				* a valid CR
	blo badcommand
	lea mnemonictbl(pc),a0	* point to command mnemonic
	lea commands(pc),a1	* the corresponding command entry point
	move.w bCmdline,d0	* current command
parsecmd:
	cmp.w (a0)+,d0		* look for command
	beq cmdproc
	add.l #4,a1		* bump to next command
	cmp.w #0,(a0)		* end of mnemonic table?
	beq badcommand
	bra parsecmd
cmdproc:
	bsr cmdreformat
         bsr enableNextCmd		* ready for next command while current command is running
	tst.l d0
	bne badcommand
	move.l (a1),a1		* get the actual subroutine address in a1
exec_cmd:
	jsr *(pc,a1)
* this is a bug with EASy68K
* correct syntax is jsr (pc,a1)
	bra dodo9		**
	
doPrompt:		**
** check fCmdDone.  If set, issue a prompt depend on the exit code.  check fTxDone first
** to make sure previous output has completed.
	tst.b fCmdDone	** every command subroutine should mark completion with fCmdDone set
	beq dodo9n	** end of AMbug task list
	cmp.b #False,fTxDone	** check if still outputting previous message
	beq dodo9n
	movem.l a0-a5/d0-d7,-(sp)	** save registers
	clr.b fCmdDone	** this is where fCmdDone is cleared
	tst.b exitCode	** exit code of a command execution determines what prompt to display
			** 0=normal exit, 1=error condition
	beq OKcommand	** normal prompt
	bra badcommand	** exit with error prompt
	
**dodo8:
* don't like this approach because D0 may contains values returned from user program via 
* 'go' command.  The content of D0 is unpredictable.  On the other hand, the value of D0
* is displayed when user program terminates, so maybe this is all right...
	cmp.w #0,d0		* test result to chose the right prompt, 0=normal prompt
				* 1=error prompt, 2=no prompt (interactive session in progress)
	beq OKcommand		* normal prompt
	cmp.w #1,d0		* check for error condition
	beq badcommand
	cmp.w #2,d0		* chk for interactive session
	beq dodo9		* interactive session in progress
	bra OKcommand		* normal prompt for all other values
badcommand:
**E	pea qprompt(pc)		* load error prompt
**E	move.l (sp)+,pStr
         lea qprompt(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
	bra docommand9
OKcommand:
**E	pea prompt(pc)		* a different way to put string address into pStr
**E	move.l (sp)+,pStr	* bounce off stack so no register is altered
         lea prompt(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
docommand9:
         bsr enableNextCmd		* ready for next command
**E	move.w #3,IMRD		* enable tx/rx interrupt
dodo9:
	movem.l (sp)+,a0-a5/d0-d7	* restore registers
dodo9n:
	rts

***********************
*
* convert ascii inputs to hex values in cmdline buffer into cmdparam
* Able to hold up to 4 long word parameters in cmdparam, cCmdparam contains the number of param
* d0.w returns valid values (0), or invalid values (1)
cmdreformat:
	movem.l d1-d2/a0/a1,-(sp)	* save
	lea bCmdline+2,a0	* start after the command mnemonic
* get rid of extra space characters
* routine here to eliminate extra spaces and no space after the last parameter
cmdrf0:
	clr.b cCmdparam		* clear command parameter count
	sub.b #2,cCmd		* if there are only two bytes, then there are no parameter
	beq cmdrf7		* exit with zero parameter count
	
	cmp.b #' ',(a0)		* first space after command is different than subsequent space
	bne cmdrf1
	lea 1(a0),a0		* same as (a0)+
	sub.b #1,cCmd		* reduce byte count for command line buffer
cmdrf1:

	move.b cCmd,d2		* d2 contains number of bytes in command buffer
	ext.w d2		* sign extend, prepare for dbra operation
	clr.l d1		* d1 accumulate each nibble of ASCII input
	lea cmdparam,a1		* a1 points to parameters
	bra cmdrf6
cmdrf2:
	move.b (a0)+,d0
	cmp.b #' ',d0		* space is parameter delimiter
	bne cmdrf3
	add.b #1,cCmdparam	* increment parameter count
	move.l d1,(a1)+	
	clr.l d1		* ready for next parameter
	bra cmdrf6
cmdrf3:
	bsr asc2hex	`	* accumulate valid ASCII into hex value
	cmp.b #$FF,d0
	beq cmdrf8
	lsl.l #4,d1
	add.b d0,d1
cmdrf6:
	dbra d2,cmdrf2
	cmp.b #4,cCmdparam	* can't have more than 4 parameters
	beq cmdrf8
	add.b #1,cCmdparam	* last parameter
	move.l d1,(a1)+
cmdrf7:
	clr.l d0		* signal a good command line
	clr.b fCmdDone		* flag the command in progress
	bra cmdrf9
cmdrf8:
	move.l #1,d0		* signal a bad command line
	move.b #1,fCmdDone	* flag the command is finished
cmdrf9:
	movem.l (sp)+,d1-d2/a0/a1	* restore
	rts

*************************** User Commands ************************************
* display memory in word, address, <count>
do_dm:
	clr.l d3		* loop count
	and.l #$FFFFFFFE,cmdparam	* make sure address is even
	move.l cmdparam,a0	* this is starting address to be displayed
	cmp.b #0,cCmdparam
	beq do_dm8		* no parameter, exit with error prompt
	cmp.b #2,cCmdparam	* one or two parameters
	bgt do_dm8
	move.b #0,bAnswer+13	* modify the bAnswer message string so not to print prompt
	cmp.b #1,cCmdparam
	beq do_dm1		* do one line of display memory
	move.l cmdparam+4,d3	* number of words to display
	bra do_dm9	
do_dm1:
	move.l a0,d1		* copy of a0
	move.w (a0)+,d0		* read the specified memory location
	bsr compuAnswer		* forming the answer in buffer
         movem.l d0/a1,-(sp)        **E save registers used in trap 15 call
         lea bAnswer,a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
         movem.l (sp)+,d0/a1         **E restore registers

**E	move.l #bAnswer,pStr	* send out the answer
**E	move.b #False,fTxDone	* start transmission
**E	move.w #3,IMRD		* enable Chan A TxRDY/RxRdy interrupts

do_dm9:
	cmp.b #True,fTxDone	* must wait for string transmission done, otherwise bAnswer
        	                           * will be overwritten with next value.  This problem can
        	                           * be solved by copying data into another buffer in trap #15
	bne do_dm9		* OS swap task here
	dbra d3,do_dm1
	move.b #$a,bAnswer+13	* restore bAnswer message string to print prompt	
	clr.l d0		* signal regular prompt
	clr.b exitCode		** exit normally
	bra do_dm9x
do_dm8:
	moveq.l #1,d0		* signal error prompt
	move.b #1,exitCode	** exit with error
do_dm9x:
	move.b #1,fCmdDone	* flag the command is finished
	rts
* display register <a|d> <0-7>
* dr without parameter displays all registers, dr a|d displays all address or data registers
* dr a0-7 displays address a0-a7, dr d0-7 displays d0-d7
do_dr:
	movem.l d0-d7/a0-a7,savd0	* save data & addr registers into system RAM
do_bp_dr:			* entry point for dr command in breapoint handler
				* the register array is already saved, do not save again
	move.l cmdparam,d2	* this is address or data register select
	cmp.b #0,cCmdparam
	beq do_dr1		* no parameter, display all registers
	cmp.b #1,cCmdparam
	bgt do_dr8		* greater than 1 parameters, exit with error prompt
	cmp.l #$a,d2		
	beq do_dr_a		* 1st parameter = $a 
	cmp.l #$d,d2		
	beq do_dr_d		* 1st parameter = $d
	cmp.l #$a0,d2		* $a0 <= parameter <= $a7
	blo do_dr8
	cmp.l #$a7,d2
	bhi do_dr_dx		* check for $d0-$d7
	moveq.l #0,d1		* display just one register
	sub.l #$a0,d2
	move.l d2,d3
	mulu.w #RegStrLen,d3	* compute string array address offset
	lsl.l #2,d2		* compute register array offset
	bra do_dra0_7
do_dr_dx:
	cmp.l #$d0,d2		* $d0 <= parameter <= $d7
	blo do_dr8		* exit with error prompt
	cmp.l #$d7,d2
	bhi do_dr8		* exit with error prompt
	moveq.l #0,d1		* display just one register
	sub.l #$d0,d2
	move.l d2,d3
	mulu.w #RegStrLen,d3	* compute string array address offset
	lsl.l #2,d2		* compute register array offset
	bra do_drd0_7
do_dr_a:
	moveq.l #7,d1		* all 8 address registers
	clr.l d3		* no string offset
	clr.l d2		* no register array offset
do_dra0_7:
	lea savA0,a0
	adda.l d2,a0
	lea regA0(pc),a1
	adda.l d3,a1
	bra do_dr2
do_dr_d:
	moveq.l #7,d1		* display all data registers
	clr.l d3		* no string offset
	clr.l d2		* no register array offset	
do_drd0_7:
	lea savD0,a0
	adda.l d2,a0
	lea regD0(pc),a1
	adda.l d3,a1
	bra do_dr2	
do_dr1:
	lea savd0,a0		* point to the register array 
	moveq.l #16,d1		* loop count +1
	lea regD0(pc),a1
do_dr2:
	bsr do_dr_reg
	adda.l #RegStrLen,a1	* increment to next message string
	adda.l #4,a0		* next register in the register array
	dbra d1,do_dr2
do_dr9:	
	clr.l d0
	clr.b exitCode		** exit normally
	bra do_dr9x
do_dr8:
	moveq.l #1,d0
	move.b #1,exitCode	** exit with error prompt
do_dr9x:
	move.b #1,fCmdDone
	rts
do_dr_reg:	
* a1 points to a null terminated message
* a0 points to save register array
**E	move.l a1,pStr
**E	move.b #False,fTxDone	* start transmission
**E	move.w #3,IMRD
         movem.l d0,-(sp)        * save registers used in trap 15 call
* a1 is already points at the null terminated message
         move.b #14,d0             **E send message without CR LF
         trap #15
         movem.l (sp)+,d0         * restore registers
* no need to wait for string transmission done because RegASCII is not reused immediately
*  The label for RegASCII needs to be output first, trap #15 task 14 checks for transmit
*  done before transmit next string.
**Edo_drd0:
**E	cmp.b #True,fTxDone	* wait for string transmission done before returning
**E	bne do_drd0		* OS swap task here
	move.l (a0),d0
	bsr reg2ascii		* convert d0 to ASCII equivalent
**E	move.l #RegASCII,pStr	* RegASCII is global variable in system RAM
**E	move.b #False,fTxDone	* start transmission
**E	move.w #3,IMRD
         movem.l a1,-(sp)        **E save registers used in trap 15 call
         lea RegASCII,a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
         movem.l (sp)+,a1         **E restore registers

**Edo_drd0a:
**E	cmp.b #True,fTxDone	* wait for string transmission done before returning
**E	bne do_drd0a		* OS swap task here	
	rts
	
do_mm:	
	and.l #$FFFFFFFE,cmdparam	* make sure address is even
	move.l cmdparam,a0	* this is starting address to be modified
	cmp.b #0,cCmdparam
	beq do_mm8		* no parameter, exit with error prompt
	cmp.b #2,cCmdparam	* one or two parameters
	bgt do_mm8		* more than two parameters, exit with error prompt
	move.b #0,bAnswer+13	* modify the bAnswer message string so not to print prompt
	cmp.b #1,cCmdparam
	beq do_mm3		* do memory modify submenu
	move.w cmdparam+6,(a0)	* modify the address with word size data, 
				* discard the upper word
	move.w (a0),d0		* read back and display
	move.l a0,d1
	bsr compuAnswer
**E	move.l #bAnswer,pStr	* send out the answer
**E	move.b #False,fTxDone	* start transmission
**E	move.w #3,IMRD		* enable Chan A TxRDY/RxRdy interrupts	
**E	bsr wTxDone
         movem.l a1,-(sp)        **E save registers used in trap 15 call
         lea bAnswer,a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
         movem.l (sp)+,a1         **E restore registers	
	clr.l d0		* signal regular prompt
	clr.b exitCode		** normal exit
	bra do_mm9x	
do_mm8:
	moveq.l #1,d0		* signal error prompt
	move.b #1,exitCode	** exit with error prompt
do_mm9x:	
	bsr iBuffer		* restore the bAnswer buffer
	bra do_mm9y
do_mm3:
* interactive session, period (.) to end session, minus (-) to go back, CR for next address
	move.b #':',bAnswer+13	* add a colon to prompt for new value
	move.b #0,bAnswer+14	* terminate string after colon
do_mm4:
	move.w (a0),d0		* read memory and display
	move.l a0,d1		* d1 contains the address
	bsr compuAnswer		* 
         movem.l a1,-(sp)        **E save registers used in trap 15 call
         lea bAnswer,a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
         movem.l (sp)+,a1         **E restore registers	
**E	move.l #bAnswer,pStr	* send out the query
**E	move.b #False,fTxDone
**E	move.w #3,IMRD
**E      bsr wTxDone                
         bsr enableNextCmd          * get ready for a new command
	move.b #1,sInteractive	* set the mm command interactive session flag
	move.l a0,mmaddress	* save the address for next interactive session
	move.l #2,d0		* signal interactive session in progress
	rts			** interactive session, return without clear the fCmdDone 
do_mm9y:
	move.b #1,fCmdDone	* flag the command is finished
	rts			
do_mr:
	movem.l d0-d7/a0-a7,savd0	* capture current register values
do_bp_mr:			* entry point for mr command in breakpoint handler
				* register array is already saved
	cmp.b #2,cCmdparam	* expect one or two parameters
	bhi do_mr8
	cmp.b #0,cCmdparam	* if no parameter, exit with error prompt
	beq do_mr8
	move.l cmdparam,d2	* get the parameter
	cmp.l #$a0,d2		* $a0 <= parameter <= $a7
	blo do_mr8
	cmp.l #$a7,d2
	bhi do_mr_dx		* check for $d0-$d7
	sub.l #$a0,d2
	move.l d2,d3
	mulu.w #RegStrLen,d3	* compute string array address offset
	lsl.l #2,d2		* compute register array offset
	lea savA0,a0		* offset from address register 0
	lea regA0(pc),a1	* array base is address register 0 string
	bra do_mr2
do_mr_dx:
	cmp.l #$d0,d2		* $d0 <= parameter <= $d7
	blo do_mr8		* exit with error prompt
	cmp.l #$d7,d2
	bhi do_mr8
	sub.l #$d0,d2
	move.l d2,d3
	mulu.w #RegStrLen,d3	* compute string array address offset
	lsl.l #2,d2		* compute register array offset
	lea savD0,a0		* array base is the data register 0
	lea regD0(pc),a1	* array base is the data register 0 string
do_mr2:
	adda.l d2,a0		* compute correct offset from base
	adda.l d3,a1		* compute correct string to display
	cmp.b #1,cCmdparam	* if one parameter, go to interactive session
	beq do_mr3
	move.l cmdparam+4,(a0)	* modified the specified register
	bsr do_dr_reg
	bra do_mr9
do_mr3:
* interactive session, period (.) to end session, minus (-) to go back, CR for next address
	move.b #':',nullchar	* replace first null character with colon prompt
do_mr4:
	bsr do_dr_reg
         bsr enableNextCmd          * initialize for new command
	bsr wUserInput		* wait for fDoCmd flag
	tst.b cCmd		* if just CR, examine/modify next register
	beq do_mr7
	cmp.b #'.',bCmdline	* period terminate the session
	beq do_mr9i
	cmp.b #'=',bCmdline	* = re-display the same register
	beq do_mr4
	cmp.b #' ',bCmdline	* no blank allow
	beq do_mr8i
	cmp.b #'-',bCmdline	* minus go back one register
	bne do_mr5
	cmp.l #savd0,a0		* make sure we are within the register array
	beq do_mr4		* don't go back one register if already register d0
	suba.l #4,a0
	suba.l #RegStrLen,a1
	bra do_mr4
do_mr5:
* cCmd may be 0 - 8.  If 0, advanced to next address, else write data to current
* register and advnced to next address.  exit session with error prompt if illegal value	
	cmp.b #8,cCmd		* no more than 8 characters should be entered
	bgt do_mr8i
	move.b cCmd,d3		* d3 is loop counter
	ext.w d3
	sub.w #1,d3		* this is the actual loop count
	clr.l d2		* d2 contains the new value for register
	move.l a1,a2		* save copy of a1
	lea bCmdline,a1
do_mr6:
	move.b (a1)+,d0		* accumulate value one nibble at a time
	bsr asc2hex
	cmp.b #$FF,d0		* exit interactive session if illegal hex value
	beq do_mr8i
	lsl.l #4,d2
	add.b d0,d2
	dbra d3,do_mr6
	move.l a2,a1		* restore original a1
	move.l d2,(a0)		* write new value into current register
do_mr7:
	cmp.l #savpc,a0		* don't increment beyond pc register
	beq do_mr4
	adda.l #4,a0		* bump to next register array
	adda.l #RegStrLen,a1	* bump to next message array
	bra do_mr4
do_mr8i:
* Interactive command consumed in this session, don't carry into next command
         bsr enableNextCmd          * initialize for new command	
	bra do_mr8
do_mr9i:
* Interactive command consumed in this session, don't carry into next command
         bsr enableNextCmd          * initialize for new command		
do_mr9:
	tst.b fdobkpt		* check for breakpoint in progress
	bne do_mr9y		* skip over the save register array if 
				* executing from breakpoint service routine
	movem.l savd0,d0-d7/a0-a7	* copy save registers back to real registers
do_mr9y:
	move.b #0,nullchar	* restore the null terminator for normal use
	clr.l d0
	clr.b exitCode		** normal exit
	bra do_mr9x
do_mr8:
	moveq.l #1,d0
	move.b #1,exitCode	** exit with error prompt
do_mr9x:
	move.b #1,fCmdDone	* flag the command is finished
	rts			
do_go:
* if no parameter, use the save register array
	cmp.b #0,cCmdparam	* if no parameter, use the save register array
	beq do_go6
	cmp.b #2,cCmdparam	* 2 parameters means breakpoint on the 2nd parameter location
	beq do_go2
	cmp.b #1,cCmdparam	* 1 parameter is the address
	bne do_go8
do_go3:
	and.l #$FFFFFFFE,cmdparam	* make sure address is even
	move.l cmdparam,a0
	jsr (a0)
	bra do_go7
do_go2:
	tst.l bkptaddr			* check if valid breakpoint already exists
	bne do_go8x
	and.l #$FFFFFFFE,cmdparam+4	* make sure the breakpoint address is even
	move.l cmdparam+4,bkptaddr	* save the breakpoint address
	move.l cmdparam+4,a0
	move.l (a0),bkptinstr		* save the instruction
	move.w #$48FC,(a0)		* insert illegal instruction
	cmp.w #$48FC,(a0)		* verify breakpoint inersertion successful
	bne do_bp8x
	bra do_go3	
do_go6:
*	movem.l savd0,d0-d7/a0-a7	* use the save register array
* abandon the idea of setting up register array with certain set of value and go
* this is something that can be done interactively during breakpoint and trace
* this function is used exclusively to support S record loading with starting address
	move.l savpc,a0			* except a0
	jsr (a0)
do_go7:
	move.l d0,savd0		* display returned value of d0
	lea savd0,a0
	lea procdonemsg(pc),a1
	bsr do_dr_reg		* display process terminated message
	move.l savd0,d0		* restore the returned value of d0
	bra do_go9x
do_go9:
	clr.l d0
	clr.b exitCode		** normal exit
	bra do_mr9x
do_go8x:
         lea badgomsg(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
**E	pea badgomsg(pc)	* print error message, breakpoint already in use
**E	move.l (sp)+,pStr
**E	move.b #3,IMRD		* enable chan a TxRDY/RxRDY interrupts
**E	move.b #False,fTxDone
**E	bsr wTxDone
do_go8:
	moveq.l #1,d0
	move.b #1,exitCode	** exit with error prompt
do_go9x:
	move.b #1,fCmdDone	* flag the command is finished
	rts
do_bp:
* breakpoint insert/display/clear
* no parameter display the current breakpoint, one parameter swap out the word in specified
*  address with illegal instruction.  bp 0 clear breakpoint
	cmp.b #0,cCmdparam	* no parameter means display breakpoint
	beq do_bp5
	cmp.b #1,cCmdparam	
	bne do_bp8
	tst.l cmdparam		* if parameter is zero, restore breakpoint
	beq do_bp3
	and.l #$FFFFFFFE,cmdparam	* make sure address is even
	move.l cmdparam,a0
	move.l cmdparam,bkptaddr	* update the breakpoint address
	move.w (a0),bkptinstr		* save the original instruction
	move.w #$48FC,(a0)		* insert illegal instr to specified location
	cmp.w #$48FC,(a0)		* verify insertion successful
	bne do_bp8x
	bra do_bp6			* display breakpoint
do_bp3:
	tst.l bkptaddr			* if no breakpoint found, display no breakpoint message
	beq do_bp7
	move.l bkptaddr,a0		* address of the original instruction
	move.w bkptinstr,(a0)		* restore original instruction
	lea bkptaddr,a0
	lea bpremovemsg(pc),a1		* display the breakpoint removed message
	bsr do_dr_reg
	clr.l bkptaddr			* no breakpoint exists
	bra do_bp9
do_bp5:	
	tst.l bkptaddr			* check if valid breakpoint exists
	beq do_bp7
do_bp6:
	lea bkptaddr,a0
	lea bkptmsg(pc),a1		* print display current breakpoint
	bsr do_dr_reg			* a0 is pointed at the address of breakpoint	
	bra do_bp9
do_bp7:
**E	pea nobpmsg(pc)			* display no breakpoint found message
**E	move.l (sp)+,pStr
**E	move.b #3,IMRD
**E	move.b #False,fTxDone
**E	bsr wTxDone
         lea nobpmsg(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15		
do_bp9:
	clr.l d0
	clr.b exitCode		** normal exit
	bra do_mr9x
do_bp8x:
* unable to insert breakpoint
	clr.l bkptaddr		* remove breakpoint
**E	pea badbpmsg(pc)
**E	move.l (sp)+,pStr
**E	move.b #3,IMRD
**E	move.b #False,fTxDone
**E	bsr wTxDone
         lea badbpmsg(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15	

do_bp8:
	moveq.l #1,d0
	move.b #1,exitCode	** exit with error prompt
do_bp9x:
	move.b #1,fCmdDone	* flag the command is finished
	rts
do_sw:
* switch CS0 and CS1 assignment, RAM (CS1) base to $0 and alias at $200000, 
* boot flash to $600000.  Restart the program	
* Because of the boot ROM base address change, The return address for all nested exceptions
* are no longer correct.  So the best thing is to reinitiate stack and jump right
* after the BR/OR initialization
*	cmp.l #$600400,$4
	move.w $0,d0		* save before testing
	move.w #$F0F0,$0	* can loc 0x0 be modified?
	cmp.w #$F0F0,$0
	bne do_sw1
	move.w d0,$0		* restore original value
         lea switchedmsg(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15	
**E	pea switchedmsg(pc)	* if switched already, put out msg and exit with error prompt
**E	move.l (sp)+,pStr
**E	move.b #False,fTxdone
**E	move.w #3,IMRD
**	bsr wTxDone
	moveq.l #1,d0		* return with error prompt
	move.b #1,exitCode	** exit with error prompt
	move.b #1,fCmdDone
	rts	
do_sw1:	
         lea switchmsg(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15	
**E	pea switchmsg(pc)	* print out the switch message
**E	move.l (sp)+,pStr
         bsr enableNextCmd          * initialize for new command
**E	move.b #False,fTxDone
**E	move.w #3,IMRD		* enable tx/rx interrupt	
	bsr wTxDone                * finish sending message out before switching
	lea sw_instr(pc),a1	* copy switch instructions to system RAM
	lea $fff100,a0		* destination
	move.w #9,d1		* one less the number of long words to move
do_sw2:
	move.l (a1)+,(a0)+	* copy source to destination
	dbra d1,do_sw2
* copy the vectors to RAM.  ROM base is now $600000, so $600000 are added to all vectors
	lea $200004,a0		* destination is RAM
	lea $4,a1		* source is boot flash, ignore the reset stack pointer
	move.w #$FE,d1		* one less the number of long words to move
do_sw3:
	move.l (a1)+,d0
	add.l #$600000,d0	* add $600000 to all vectors
	move.l d0,(a0)+
	dbra d1,do_sw3
	move.b #1,fCmdDone	* flag the command is finished	
	jmp $fff100		* will not return
do_help:
**E	pea helpmsg(pc)		* print out help message
**E	move.l (sp)+,pStr
**E	move.b #3,IMRD		* enable Chan A TxRDY/RxRdy interrupts
**E	move.b #False,fTxDone
**	bsr wTxDone
         lea helpmsg(pc),a1         **E A1 points at the help message
         move.b #14,d0              **E output null terminated string without LR/CF
         trap #15
	clr.l d0
	clr.b exitCode		** normal exit
	move.b #1,fCmdDone	* flag the command is finished	
	rts
	
mminteractive:
* this is the interactive session for mm command
	move.l mmaddress,a0	* restore address to be modified
	tst.b cCmd		* if just CR, modify next address
	beq mminteract1
	cmp.b #'.',bCmdline	* period terminate the session
	beq mminteract9
	cmp.b #'=',bCmdline	* = re-display the same address
	beq mminteract2
	cmp.b #' ',bCmdline	* no blank allow
	beq mminteract8
	cmp.b #'-',bCmdline	* minus go back one word address
	beq mminteract3
* cCmd may be 0 - 4.  If 0, advanced to next address, else write data to current
* memory and advnced to next address.  exit session with error prompt if illegal value	
	cmp.b #4,cCmd
	bgt mminteract8
	move.b cCmd,d3		* d3 is loop count
	ext.w d3		* get d3 ready for dbra operation
	sub.w #1,d3		* the actual loop count is one less
	clr.l d2		* d2 contains the new data value
	lea bCmdline,a1
mminteract6:
	move.b (a1)+,d0		* accumulate value one nibble at a time
	bsr asc2hex
	cmp.b #$FF,d0		* exit session if illegal hex value
	beq mminteract8
	lsl.l #4,d2
	add.b d0,d2
	dbra d3,mminteract6
	move.w d2,(a0)		* write new data value into current address
mminteract1:	
	add.l #2,a0		* next address location
	bra mminteract2
mminteract3:
	sub.l #2,a0
mminteract2:
	move.w (a0),d0		* read memory and display
	move.l a0,d1		* d1 contains the address
	bsr compuAnswer		* 
         movem.l a1,-(sp)        **E save registers used in trap 15 call
         lea bAnswer,a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
         movem.l (sp)+,a1         **E restore registers	
**E	move.l #bAnswer,pStr	* send out the query
**E	move.b #False,fTxDone
**E	move.w #3,IMRD
         bsr enableNextCmd          * initialize for new command
*	bsr wTxDone		* finish sending string
*	move.b #1,sInteractive	* set the mm command interactive session flag
	move.l a0,mmaddress	* save the address for next interactive session
	move.l #2,d0		* signal interactive session in progress
	bra mminteract9y
mminteract8:
	moveq.l #1,d0		* error prompt
	move.b #1,exitCode	** exit with error prompt
	bra mminteract9x
mminteract9:
	clr.l d0		* normal prompt
	clr.b exitCode		** normal exit
mminteract9x:
	clr.b sInteractive	* interactive session is over
	bsr iBuffer		* restore the bAnswer buffer content
** mminteract9y:
	move.b #1,fCmdDone	* flag the command is finished
mminteract9y:			** return without setting the fCmdDone flag
				** session not over
* Interactive command consumed in this session, don't carry into next command
         bsr enableNextCmd          * initialize for new command
	rts
	

do_du:	
         rts
* consolidate waiting for string transmission done here to facilitate OS later
	clr.b exitCode
	move.b #1,fCmdDone
	rts
wTxDone:
	cmp.b #True,fTxDone	* wait for string transmission done before returning
	bne wTxDone		* OS swap task here
	rts
enableNextCmd:
* These are setup for next command
         move.l #bCmdline,pCmdln  * point to beginning of command line
         clr.b fDoCmd               * clear the command ready flag
         clr.b cCmd                 * clear the command buffer character count
         rts 
wUserInput:
	tst.b fDoCmd		* wait for user input
	beq wUserInput		* OS swap task here
	rts
signon	dc.b $a,$d,'AMBug v2.03A 8/5/2017',$a,$d,'type "he" for help',$a,$d,'> ',0
prompt 	dc.b $a,$d,'> ',0
qprompt	dc.b $a,$d,'?> ',0
zmemmsg	dc.b $a,$d,'register memory cleared',$a,$d,'> ',0
berrmsg	dc.b $a,$d,'Bus Error!',$a,$d,'Faulted address is: ',0
illegalmsg dc.b $a,$d,'Illegal instruction at: ',0
pcmsg	dc.b $a,$d,'Program counter is: ',0
addrerrmsg dc.b $a,$d,'Address Error!',$a,$d,'Faulted address is: ',0
badgomsg dc.b $a,$d,'Breakpoint already in use, unable to execute go to breakpoint',0
runSrecord dc.b $a,$d,'Valid S records received, executing from starting address',0
validSrecord dc.b $a,$d,'Valid S records received',$a,$d,'> ',0
rundoneSR dc.b $a,$d,'S records execution completed',0
procdonemsg dc.b $a,$d,'Process completed.  Reg D0 returns: ',0
helpmsg dc.b $a,$d,'Commands are in lower case, <>optional, []mandatory'
	dc.b $a,$d,'dm [address] <count>'
	dc.b $a,$d,'dr <a|d|a0-a7|d0-d7>  Display all registers if no parameter'
	dc.b $a,$d,'mm [address] <value>  If only address entered, a submenu will follow:'
	dc.b $a,$d,'      . terminates submenu session',$a,$d,'      - go back one word address'
	dc.b $a,$d,'      = display current address again'
	dc.b $a,$d,'      [value] modify current address and display next address'
	dc.b $a,$d,'      CR not modify current address but display next address'
	dc.b $a,$d,'mr [a0-a7|d0-d7] <value>  If only register entered, a submenu will follow:'
	dc.b $a,$d,'      . terminates submenu session',$a,$d,'      - go back one register'
	dc.b $a,$d,'      = display current register again'
	dc.b $a,$d,'      [value] modify current register and display next register'
	dc.b $a,$d,'      CR not modify current register but display next register'
	dc.b $a,$d,'go <from_addr> <to_addr> If no address specified, use save register values'
	dc.b $a,$d,'bp <addr>  If no address specified, display current break point'
	dc.b $a,$d,'      special case: bp 0 removes breakpoint'
	dc.b $a,$d,'sw  switch CS0 and CS1, RAM base to $0 alias at $200000, ROM base to $600000'
	dc.b $a,$d,'du [address] [word count] dump specified number of words',0

bphelpmsg dc.b $a,$d,'dm [address] <count>'
	dc.b $a,$d,'dr <a|d|a0-a7|d0-d7>  Display all registers if no parameter'
	dc.b $a,$d,'mm [address] <value>  If only address entered, a submenu will follow:'
	dc.b $a,$d,'      . terminates submenu session',$a,$d,'      - go back one word address'
	dc.b $a,$d,'      = display current address again'
	dc.b $a,$d,'      [value] modify current address and display next address'
	dc.b $a,$d,'      CR not modify current address but display next address'
	dc.b $a,$d,'mr [a0-a7|d0-d7] <value>  If only register entered, a submenu will follow:'
	dc.b $a,$d,'      . terminates submenu session',$a,$d,'      - go back one register'
	dc.b $a,$d,'      = display current register again'
	dc.b $a,$d,'      [value] modify current register and display next register'
	dc.b $a,$d,'      CR not modify current register but display next register'
	dc.b $a,$d,'gt <addr>  Set a breakpoint at specified address and resume program execution'
	dc.b $a,$d,'      if no address specified, resume normal program execution'
	dc.b $a,$d,'bp <addr>  If no address specified, display current break point'
	dc.b $a,$d,'      special case: bp 0 removes breakpoint'
	dc.b $a,$d,'tr <count>  Trace instruction execution <count> times'
	dc.b $a,$d,'      if no parameter specified, trace one instruction'
	dc.b $a,$d,'vb  Toggle verbose mode on or off'
	dc.b $a,$d,'[carriage return] trace one instruction',0
	
q_no_cr	dc.b '?',0
bpprompt dc.b $a,$d,'BP> ',0	* prompt used in breakpoint session
bpqprompt dc.b $a,$d,'BP?> ',0
bppromptnc dc.b ' BP>',0	* prompt without carriage return.
nobpmsg	dc.b $a,$d,'No breakpoint specified',0
badbpmsg dc.b $a,$d,'Unable to insert breakpoint',0
bkptmsg dc.b $a,$d,'Breakpoint at: ',0
bpremovemsg dc.b $a,$d,'Breakpoint removed from: ',0
tracemsg dc.b $a,$d,'Trace --> Next instr:',0
tracepcmsg dc.b ' at addr:',0
tracestmsg dc.b ' current Status:',0
verbosemsg dc.b $a,$d,'Verbose mode is On',0
simplemsg dc.b $a,$d,'Verbose mode is Off',0
switchedmsg dc.b $a,$d,'Already switched, boot flash is currently at $600000',0
switchmsg dc.b $a,$d,'Switch RAM to $0 and alias at $200000, Boot flash to $600000',0
	org (*+1)&-2
sw_instr dc.w $33FC,$1800,$00FF,$F836		* move.w #$1800,$FFF836
				* OR1, 1 wait, R/W, 4096K space aliased in $0 and $200000
	dc.w $33FC,$0001,$00FF,$F834		* move.w #$0001,$FFF834
				* BR1, $000000, CS1, RAM
	dc.w $33FC,$CC01,$00FF,$F830 	* move.w #$CC01,$FFF830					
				* BR0, $600000, CS0 Flash
* Because of the boot ROM base address change, The return address for all nested exceptions
* are no longer correct.  So the best thing is to reinitiate stack and jump right
* after the BR/OR initialization
	dc.w $46FC,$2700,$4FF9,$21,$0FFC,$4EF9,$60,$0450	
		* move.w #$2700,sr        * mask off all interrupts
		* lea $210FFC,sp          * reset the stack
		* jmp $600450             * jump around the chipselect 0/1 initialization				
regD0	dc.b $a,$d,'Register D0: ',0
regD1	dc.b $a,$d,'Register D1: ',0
regD2	dc.b $a,$d,'Register D2: ',0
regD3	dc.b $a,$d,'Register D3: ',0
regD4	dc.b $a,$d,'Register D4: ',0
regD5	dc.b $a,$d,'Register D5: ',0
regD6	dc.b $a,$d,'Register D6: ',0
regD7	dc.b $a,$d,'Register D7: ',0
regA0	dc.b $a,$d,'Register A0: ',0	
regA1	dc.b $a,$d,'Register A1: ',0
regA2	dc.b $a,$d,'Register A2: ',0
regA3	dc.b $a,$d,'Register A3: ',0
regA4	dc.b $a,$d,'Register A4: ',0
regA5	dc.b $a,$d,'Register A5: ',0
regA6	dc.b $a,$d,'Register A6: ',0
regA7	dc.b $a,$d,'Register A7: ',0
regPC	dc.b $a,$d,'Program Counter (for "go" command use only): ',0	*PC had different length
regD0short dc.b $a,$d,'D0: ',0
regD1short dc.b '  D1: ',0
regD2short dc.b '  D2: ',0
regD3short dc.b '  D3: ',0
regD4short dc.b $a,$d,'D4: ',0
regD5short dc.b '  D5: ',0
regD6short dc.b '  D6: ',0
regD7short dc.b '  D7: ',0
regA0short dc.b $a,$d,'A0: ',0
regA1short dc.b '  A1: ',0
regA2short dc.b '  A2: ',0
regA3short dc.b '  A3: ',0
regA4short dc.b $a,$d,'A4: ',0
regA5short dc.b '  A5: ',0
regA6short dc.b '  A6: ',0
regA7short dc.b '  A7: ',0
regstrlen equ regA7-regA6	* compute the length of each string

	org (*+1)&-2
******************* subroutines*************************
*
* clear a chunk of RAM area as pointed by a5
clrRAMa5:
	movem.l d0/a5,-(sp)	* save
	move.w #$1000,d0		* clear a 16K block
clrRAM0:
	clr.l (a5)+
	dbra d0,clrRAM0
	movem.l (sp)+,d0/a5	* restore
	rts
*
* clear the saved register area in the system RAM
clrsavr:
	lea savd0,a0		* savd0 is the beginning of register block
	move.w #16,d0		* 17 registers total
clrsavr0:
	clr.l (a0)+
	dbra d0,clrsavr0
	clr.w (a0)+		* this clear the exception counter
	lea $2F8000,a5		* $2F8000 to 2FBFFF is diagnostic area
	bsr clrRAMa5
	rts
*
* initialize the various buffers
iBuffer:
	move.b #$a,bAnswer	* start with LF, CR
	move.b #$d,bAnswer+1
	move.b #':',bAnswer+8	* separator
	move.b #$a,bAnswer+13
	move.b #$d,bAnswer+14
	move.b #'>',bAnswer+15
	move.b #' ',bAnswer+16
	move.b #0,bAnswer+17	* zero terminator
	rts

*
* initialize the DUART 68692, only lower byte is connected to data bus d0-d7
* interrupt is connected to PB8 of 68302, nIACK is tied to VCC, need manual service
* of interrupt
iDUART:
	move.w #$13,MRA		* write to MR1A as follow:
			* no RxRTS, RxRDY int, Char error, no parity, 8 bits
	move.w #$07,MRA		* now write to MR2A as follow:
			* normal, no TxRTS, no CTS, 1 stop
	move.w #$60,ACR		* clear ACR[7] bit
	move.w #$CC,CSRA	* 38.4K baud
	move.w #$0,IMRD		* mask off interrupt
	move.w #$A,CRA		* disable Chan A transmit and receive
	rts
iEASyDisplay:
* initialize EASy68k hardware display
         move.b #$80,Ctrl82C55         * set all 82C55 discretes to outputs
         move.b #6,PortC82C55          * turns off switch inputs, turn on display driver,
                                    * turns off LEDs
         move.b #0,PortA82C55          * turns off all 7-seg display
         rts                         
*
* check for valid ascii representation of hexdecimal
* d0 contains input, return 0xFF if invalid, otherwise hex value
asc2hex:
	cmp.b #'f',d0		
	bhi aschex9		* not valid, >'f'
	cmp.b #'a'-1,d0
	bhi aschex1		* 'f'> valid >'a'
	cmp.b #'F',d0		
	bhi aschex9		* not valid, >'F'
	cmp.b #'A'-1,d0
	bhi aschex3		* 'F'> valid >'A'
	cmp.b #'9',d0
	bhi aschex9		* not valid >'9'
	cmp.b #'0'-1,d0
	bhi aschex2		* '9'> valid >'0'
aschex9:
	move.b #$FF,d0		* return 0xFF in not hex
	bra aschex0
aschex3:
	sub.b #$37,d0
	bra aschex0
aschex2:
	sub.b #$30,d0
	bra aschex0
aschex1:
	sub.b #$57,d0		* 'a'-'f'
aschex0:	
	rts
*
* hex to ascii
* byte value in d0.b is converted to ascii in d0.w
hex2asc:
	movem.l d1,-(sp)
	move.b d0,d1
	lsr.b #4,d1		* get the high nibble first
	add.b #$30,d1
	cmp.b #'9',d1		* '0' to '9'
	bls hex2asc7
	add.b #7,d1		* or 'A' to 'F'
hex2asc7:
	lsl.w #8,d1		* put result in high byte
	move.b d0,d1		* work on the low nibble
	and.b #$F,d1		* isolate low nibble
	add.b #$30,d1
	cmp.b #'9',d1		* '0' to '9'
	bls hex2asc8
	add.b #7,d1		* or 'A' to 'F'
hex2asc8:
	move.l d1,d0		* done
	movem.l (sp)+,d1
	rts
*
* convert content of register d0 into ASCII equivalent and store in RegASCII system buffer
reg2ascii:
	movem.l d1,-(sp)	* save
	move.l d0,d1	* save a copy
	rol.l #8,d0	* do MSB first
	bsr hex2asc
	move.w d0,RegASCII
	move.l d1,d0	* restore the copy
	swap d0		* do MUB next
	bsr hex2asc
	move.w d0,RegASCII+2
	move.l d1,d0
	ror.l #8,d0	* do MLB next
	bsr hex2asc
	move.w d0,RegASCII+4
	move.l d1,d0	* do LSB last
	bsr hex2asc
	move.w d0,RegASCII+6
	movem.l (sp)+,d1	* restore
	rts
*
* transmit a null-terminated string pointed by a0
TxStringA0:
	movem.l d0,-(sp)	* save d0
TxStr1:
	btst.b #2,SRA+1		* look for transmit ready
	beq TxStr1
	move.b (a0)+,d0
	beq Txstr9
	move.b d0,THRA+1
	bra TxStr1
TxStr9:
	btst.b #2,SRA+1		* wait for transmit done before restart
	beq TxStr9
	movem.l (sp)+,d0	* restore
	rts
*
* transmit the content of d0 register
TxRegD0:
	movem.l d1/d2,-(sp)	* save
	move.w #3,d2
txregd01:
	rol.l #8,d0	* do the MSB first
	move.l d0,d1	* save a copy
	bsr hex2asc
	ror.w #8,d0	* print the high nibble of byte first
	bsr txregd0q			
	bsr txregd0q
	move.l d1,d0
	dbra d2,txregd01
	movem.l (sp)+,d1/d2	* restore
	rts
txregd0q:
	btst.b #2,SRA+1
	beq txregd0q
	move.b d0,THRA+1
	ror.w #8,d0
	rts
* form the answer in buffer
* d0 is the value, d1 is the address
compuAnswer:
	movem.l d1/d2,-(sp)	* save 
	move.w d0,d2		* save a copy of d0
	bsr hex2asc
	move.b d0,bAnswer+12	
	lsr.w #8,d0		* get the middle-lowerbyte
	move.b d0,bAnswer+11	* get the LSB byte
	move.w d2,d0
	lsr.w #8,d0
	bsr hex2asc
	move.b d0,bAnswer+10	* do the MSB byte
	lsr.w #8,d0
	move.b d0,bAnswer+9
	move.b d1,d0		* do the address value
	bsr hex2asc
	move.w d0,bAnswer+6	* LSW of address
	lsr.l #8,d1
	move.b d1,d0
	bsr hex2asc
	move.w d0,bAnswer+4	* middle word of address
	lsr.l #8,d1
	move.b d1,d0
	bsr hex2asc
	move.w d0,bAnswer+2	* MSW word of address (24-bit address)
	movem.l (sp)+,d1/d2	* restore
	rts
time2string:
* convert packed bcd representation of yymmddhhmmss stored in rtctimebcd into 
* formated 20yy/mm/dd hh:mm:ss with null terminator in rtctime
	movem.l d0-d1/a0,-(sp)	* save regs
	lea rtctime,a0		* points to time storage
	move.w #'20',(a0)+	* year is 20xx
	move.l rtctimebcd,d0	* get yymmddhh
	move.l d0,d1
	and.l #$f0f0f0f0,d1	* pick out 2nd digit of yymmddhh
	and.l #$0f0f0f0f,d0	* pick out 1st digit of yymmddhh
	add.l #$30303030,d0	* convert to ascii
	ror.l #4,d1
	add.l #$30303030,d1	* convert to ascii
	rol.l #8,d1
	rol.l #8,d0
	move.b d1,(a0)+		* yy/
	move.b d0,(a0)+
	move.b #'/',(a0)+
	rol.l #8,d1
	rol.l #8,d0
	move.b d1,(a0)+		*mm/
	move.b d0,(a0)+
	move.b #'/',(a0)+
	rol.l #8,d1
	rol.l #8,d0
	move.b d1,(a0)+		*dd + space
	move.b d0,(a0)+
	move.b #' ',(a0)+
	rol.l #8,d1
	rol.l #8,d0
	move.b d1,(a0)+		*hh:
	move.b d0,(a0)+
	move.b #':',(a0)+	
	move.w rtctimebcd+4,d0	* get mmss
	move.l d0,d1
	and.w #$f0f0,d1		* pick out 2nd digit of mmss
	and.w #$0f0f,d0		* pick out 1st digit of mmss
	ror.w #4,d1
	add.w #$3030,d0		* convert to ascii
	add.w #$3030,d1	
	rol.w #8,d1
	rol.w #8,d0
	move.b d1,(a0)+		* mm:
	move.b d0,(a0)+
	move.b #':',(a0)+
	rol.w #8,d1
	rol.w #8,d0
	move.b d1,(a0)+		* ss + null 
	move.b d0,(a0)+
	move.b #0,(a0)+	
	movem.l (sp)+,d0-d1/a0
	rts	
*@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
*
* unexpected exception
* stay here and blink light green at 1/10 second and red at 1/5 second
unknown:
	add.w #1,cUErr
	movem.l d0-d7/a0-a7,savd0	* save away registers
	move.l $2(sp),savpc
unknown3:
	move.w #$0408,PBDAT	* green LED
	move.l #77000,d0	* 100ms of spin
unknown1:
	sub.l #1,d0
	bne unknown1
	move.w #0,PBDAT		* red LED
	move.l #154000,d0	* 200ms of red
unknown2:
	sub.l #1,d0
	bne unknown2
	bra unknown3		* never exit here
*
* address error
* stay here and blink light red/green at 1/5 second rate
addrerr:
	add.w #$100,cUErr
	movem.l d0-d7/a0-a7,savd0	* save away registers
	move.l $A(sp),savpc

	lea addrerrmsg(pc),a0
	bsr TxStringA0
	move.l 2(sp),d0		* print the access address
	bsr TxRegD0
	lea pcmsg(pc),a0	* print program counter
	bsr TxStringA0
	move.l $a(sp),d0
	bsr TxRegD0
	bra unknown		* blink lights forever
*
* Use illegal instruction as breakpoint.  original instruction is stored in bkptinstr
* 
breakpt:
	movem.l d0-d7/a0-a7,savd0	* save all registers
	move.l 2(sp),d0		* get the breakpoint address
	cmp.l bkptaddr,d0	* if equal, this is the user specified breakpoint
	bne breakpt8
	lea bkptmsg(pc),a1	* print breakpoint message
	lea bkptaddr,a0		* breakpoint location
	bsr do_dr_reg
	tst.b fbpverbose	* if verbose flag is set, display all registers
	bne breakpt1
         movem.l d0/a1,-(sp)        **E save registers used in trap 15 call
         lea bppromptnc(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
         movem.l (sp)+,d0/a1         **E restore registers	
**E	pea bppromptnc(pc)
**E	move.l (sp)+,pStr
	bra breakpt2
breakpt1:	
	bsr displayall
         movem.l d0/a1,-(sp)        **E save registers used in trap 15 call
         lea bpprompt(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
         movem.l (sp)+,d0/a1         **E restore registers	
**E	pea bpprompt(pc)	* put out prompt for breakpoint session
**E	move.l (sp)+,pStr
breakpt2:
	move.l 2(sp),a0
	move.w bkptinstr,(a0)	* restore original instruction
	clr.l bkptaddr		* remove breakpoint
	move.b #1,fdobkpt
         bsr enableNextCmd          * initialize for new command
**E	move.w #3,IMRD		* enable tx/rx interrupt
bpcmdloop:
	bsr wUserInput		* wait for user input	
	cmp.b #0,cCmd		* if a carriage return, do one trace instruction
	beq do_crlf
	cmp.b #2,cCmd		* need at least 2 char in command line before
				* a valid CR
	blo badbpcmd
	lea bpmnemonictbl(pc),a0	* point to command mnemonic
	lea bpcommands(pc),a1	* the corresponding command entry point
	move.w bCmdline,d0	* current command
parsebpcmd:
	cmp.w (a0)+,d0		* look for command
	beq bpcmdproc
	add.l #4,a1		* bump to next command
	cmp.w #0,(a0)		* end of mnemonic table?
	beq badbpcmd
	bra parsebpcmd
bpcmdproc:
	bsr cmdreformat
         bsr enableNextCmd          * initialize for new command
	tst.l d0
	bne badbpcmd
	move.l (a1),a1		* get the actual subroutine address in a1
exec_bpcmd:
* this is a bug with EASy68K
* correct syntax is jsr (pc,a1)
	jsr *(pc,a1)		* PC relative jsr
	tst.w d0		* test result to chose the right prompt
	beq nobpcmd
badbpcmd:
         movem.l d0/a1,-(sp)        **E save registers used in trap 15 call
         lea bpqprompt(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
         movem.l (sp)+,d0/a1         **E restore registers	
**E	pea bpqprompt(pc)		* load error prompt
**E	move.l (sp)+,pStr
	bra nobpcmd9
nobpcmd:
         movem.l d0/a1,-(sp)        **E save registers used in trap 15 call
         lea bpprompt,a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15
         movem.l (sp)+,d0/a1         **E restore registers	
**E	pea bpprompt(pc)		* a different way to put string address into pStr
**E	move.l (sp)+,pStr	* bounce off stack so no register is altered
nobpcmd9:
         bsr enableNextCmd          * initialize for new command
**E	move.w #3,IMRD		* enable tx/rx interrupt
	bra bpcmdloop
do_crlf:			* carriage return trace one instruction
	clr.w cTrace
	move.w (sp),d0		* locate the status register of breakpoint exception
	and.w #$3FFF,d0		* enable trace
	or.w #$8000,d0
	move.w d0,(sp)
	bra breakpt9
do_tr:
	clr.w cTrace		* clear the trace count for now
	cmp.b #1,cCmdparam	* expect one parameters
	bhi do_tr8
	cmp.b #0,cCmdparam	* if no parameter, do trace once
	beq do_tr4
	move.w cmdparam+2,cTrace	* trace loop count	
do_tr4:
	move.w 4(sp),d0		* locate the status register for breakpoint
	and.w #$3FFF,d0		* trace every instruction
	or.w #$8000,d0
	move.w d0,4(sp)
	add.l #4,sp		* adjust stack, not returning back to subroutine
	bra breakpt9		* exit breapoint exception with specified trace bits
do_tr8:
	move.l #1,d0		* return to BP session with error prompt
	rts
breakpt8:	
	lea illegalmsg(pc),a0
	bsr TxStringA0
	move.l 2(sp),d0
	bsr TxRegD0
	bsr do_dr1		* display all registers
	bra unknown
do_goto:
	cmp.b #0,cCmdparam	* expect zero or one parameter
	beq do_gt2
	cmp.b #1,cCmdparam
	bne do_tr8		* same error handling as in trace parameter handling
	move.l cmdparam,bkptaddr	* save to bkpt address
	move.l cmdparam,a0
	move.w (a0),bkptinstr	* save the instruction
	move.w #$48FC,(a0)	* insert illegal instruction to specified location
do_gt2:
	move.w 4(sp),d0		* locate the status register for breakpoint
	and.w #$3FFF,d0		* turn trace bits to zero
	move.w d0,4(sp)		* put it back
	add.l #4,sp		* adjust stack, not returning back to subroutine
breakpt9:
         bsr enableNextCmd          * initialize for new command
	clr.b fdobkpt		* clear the breakpoint in progress flag
	movem.l savd0,d0-d7/a0-a7	* restore registers	
	rte	

* BP command dispatch tables
bpcommands:	
	dc.l do_dm-exec_bpcmd	* display memory
	dc.l do_bp_dr-exec_bpcmd	* display register
	dc.l do_mm-exec_bpcmd	* modify memory
	dc.l do_bp_mr-exec_bpcmd	* modify register
	dc.l do_goto-exec_bpcmd	* go till next breakpoint
	dc.l do_bp-exec_bpcmd	* breakpoint
	dc.l do_tr-exec_bpcmd	* trace
	dc.l do_vb-exec_bpcmd	* verbose flag
	dc.l do_bphelp-exec_bpcmd	* help message		
* corresponding mnemonic for the breakpoint command table
bpmnemonictbl:
	dc.w 'dm'
	dc.w 'dr'
	dc.w 'mm'
	dc.w 'mr'
	dc.w 'gt'
	dc.w 'bp'
	dc.w 'tr'
	dc.w 'vb'
	dc.w 'he'
	dc.w $0	

***********************BP commands***************************
do_vb:
* toggle the verbose mode, whatever additional parameters are ignored
	tst.b fbpverbose
	bne do_vb2
         lea verbosemsg(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15	
**E	pea verbosemsg(pc)
**E	move.l (sp)+,pStr
	move.b #1,fbpverbose	* verbose mode is On
	bra do_vb9
do_vb2:
	move.b #0,fbpverbose	* verbose mode is off
         lea simplemsg(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15	
**E	pea simplemsg(pc)
**E	move.l (sp)+,pStr
do_vb9:	
**E	move.b #3,IMRD		* enable chan A TxRdy/RxRdy interrupts
**E	move.b #False,fTxDone
**E	bsr wTxDone
	clr.l d0
	clr.b exitCode		** normal exit
	move.b #1,fCmdDone	* flag the command is finished
	rts
do_bphelp:
         lea bphelpmsg(pc),a1          **E sign on message
         move.b #14,d0             **E send message without CR LF
         trap #15	
**E	pea bphelpmsg(pc)	* print out help message
**E	move.l (sp)+,pStr
**E	move.b #3,IMRD		* enable Chan A TxRDY/RxRdy interrupts
**E	move.b #False,fTxDone
**E	bsr wTxDone
	clr.l d0
	clr.b exitCode		** normal exit
	move.b #1,fCmdDone	* flag the command is finished	
	rts

displayall:
	lea regD0short(pc),a1
	lea savd0,a0
	bsr do_dr_reg
	lea regD1short(pc),a1
	lea savd1,a0
	bsr do_dr_reg
	lea regD2short(pc),a1
	lea savd2,a0
	bsr do_dr_reg
	lea regD3short(pc),a1
	lea savd3,a0
	bsr do_dr_reg
	lea regD4short(pc),a1
	lea savd4,a0
	bsr do_dr_reg
	lea regD5short(pc),a1
	lea savd5,a0
	bsr do_dr_reg	
	lea regD6short(pc),a1
	lea savd6,a0
	bsr do_dr_reg	
	lea regD7short(pc),a1
	lea savd7,a0
	bsr do_dr_reg	
	
	lea regA0short(pc),a1
	lea savA0,a0
	bsr do_dr_reg
	lea regA1short(pc),a1
	lea savA1,a0
	bsr do_dr_reg
	lea regA2short(pc),a1
	lea savA2,a0
	bsr do_dr_reg
	lea regA3short(pc),a1
	lea savA3,a0
	bsr do_dr_reg
	lea regA4short(pc),a1
	lea savA4,a0
	bsr do_dr_reg
	lea regA5short(pc),a1
	lea savA5,a0
	bsr do_dr_reg	
	lea regA6short(pc),a1
	lea savA6,a0
	bsr do_dr_reg	
	lea regA7short(pc),a1
	lea savsp,a0
	bsr do_dr_reg
	rts
	
*
* trace exception handling
* display PC, status, and instruction
trace:
	movem.l d0-d7/a0-a7,savd0	* save all registers
         bsr enableNextCmd          * initialize for new command
trace1:
	lea tracemsg(pc),a0
	bsr TxStringA0		* send out trace message
	move.l 2(sp),a0		* get program counter of instruction
	move.l (a0),d0		* get the instruction being traced
	bsr TxRegD0
	lea tracepcmsg(pc),a0
	bsr TxStringA0		* next line of trace message
	move.l 2(sp),d0
	bsr TxRegD0		* print pc value
	lea tracestmsg(pc),a0
	bsr TxStringA0
	clr.l d0
	move.w (sp),d0
	bsr TxRegD0
	sub.w #1,cTrace		* decrement trace loop count
				* if zero, no more trace, insert breakpoint for next instruction
	bgt trace7
trace5:
	move.w (sp),d0
	and.w #$3FFF,d0		* remove trace
	move.w d0,(sp)		* put back status word
	move.l 2(sp),a0		* breakpoint for next instruction
	move.w (a0),bkptinstr	* save original instruction
	move.w #$48FC,(a0)	* illegal instruction
	move.l 2(sp),bkptaddr	* save away breakpoint address
	bra trace9
trace7:
	tst.b fbpverbose
	beq trace9
	bsr displayall
trace9:
	movem.l savd0,d0-d7/a0-a7
	rte
************ EASy68K trap routines *********************         
EASyTrapTbl:	
***** Text I/O *****
	bra.w EASy0
	bra.w EASy1
	bra.w EASy2
	bra.w EASy3
	bra.w EASy4
	bra.w EASy5
	bra.w EASy6
	bra.w EASy7
	bra.w EASy8
	bra.w EASy9
	bra.w EASy10
	bra.w EASy11
	bra.w EASy12
	bra.w EASy13
	bra.w EASy14
	bra.w EASy15
	bra.w EASy16
	bra.w EASy17
	bra.w EASy18
	bra.w EASy19
	bra.w EASy20
	bra.w EASy21
	bra.w EASy22
	bra.w EASy23
	bra.w EASy24
	bra.w EASy25
	bra.w EASy80
         bra.w EASy81
         bra.w EASy82
         bra.w EASy83
         bra.w EASy84
         bra.w EASy85
         bra.w EASy86
         bra.w EASy87
         bra.w EASy88
         bra.w EASy89
         bra.w EASy90
         bra.w EASy91
         bra.w EASy92
         bra.w EASy93
         bra.w EASy94
         bra.w EASy95
         bra.w EASy96

******* Graphic ****
	
* not yet implemented trap
EASy0:
EASy1:
EASy2:
EASy3:
EASy4:
EASy9:
EASy10:
EASy11:
EASy15:
EASy16:
EASy17:
EASy18:
EASy19:
EASy20:
EASy21:
EASy22:
EASy23:
EASy24:
EASy25:
EASy80:
EASy81:
EASy82:
EASy83:
EASy84:
EASy85:
EASy86:
EASy87:
EASy88:
EASy89:
EASy90:
EASy91:
EASy92:
EASy93:
EASy94:
EASy95:
EASy96:
	rts

EASyTrap:
* EASy68K trap services
 
	movem.l a3/d3,-(sp)  * save registers
         lea EASyTrapTbl(pc),a3     * a position independ table of trap routines
         cmp.b #25,d0      * modify index is taks # is greater than 25
         ble calcEASyTask
         sub.b #54,d0      * modified index for task #80 and up
calcEASyTask:
	clr.l d3		* setup to index into the trap service table
	move.b d0,d3      * d0 contains the index value
	lsl.l #2,d3	* compute long word offset
	jsr (a3,d3)      * jsr into array of trap routines        
EASyT15z: 
	movem.l (sp)+,a3/d3 * restore register
	rte
EASy5:   
* Read single ASCII character from the keyboard into D1.B
	btst.b #0,SRA+1		* Does receiver has a char input
	beq EASy5		* wait until it has an input
	move.b RHRA+1,d1	* get character into d1.b
	tst.b fEASyTEcho
	bne EASy6               * echo back char for T15Echo != 0	
	rts	         		    
EASy6:	
* Display single ASCII character in D1.B.
	btst.b #2,SRA+1		* look for transmit ready
	beq EASy6                                 
	move.b d1,THRA+1        * put char in d1.b out to serial port    
	rts
EASy7:
* Check for keyboard input. Set D1.B to 1 if keyboard input is pending, otherwise set to 0.
* Use task 2 or 5 to read pending key.
         move.b #0,d1      * assume there is no char input
         btst.b #0,SRA+1   * Does receiver has a char input?
         beq EASy7z
         move.b #1,d1      * A char input is ready
EASy7z:
         rts

EASy8:
* Return time in hundredths of a second since midnight in D1.L. 
	move.l wallclock,d1	* wallclock is increment every 10ms
	rts
EASy12:  
* Keyboard Echo. 
* D1.B = 0 to turn off keyboard echo. 
* D1.B = non zero to enable. (default). 
* Echo is restored on 'Reset' or when a new file is loaded
	move.b d1,fEASyTEcho       * store echo value
         rts
EASy13:
EASy14:
* task 13: Display the NULL terminated string at (A1) with CR, LF.
* task 14: Display the NULL terminated string at (A1) without CR, LF.
* send null terminated string pointed by A1 to console.  No CR, LF added
* if transmitter is unavailable, wait until it is available
	cmp.b #True,fTxDone	* wait for string transmission done before proceeding
	bne EASy14		* possible OS swap task here
	move.l a1,pStr		* pStr points to null-terminated message
	move.b #False,fTxDone	* start transmission
	clr.b fEASyTCRLF           * assume it is task 14 (no CR LF)
	cmp.b #14,d0               
         beq EASy14z	         * if task 14, don't change CR/LF flag
         move.b #1,fEASyTCRLF       * task 13, add carriage, line feed to the end of message        
EASy14z:
	move.w #3,IMRD		* enable Chan A TxRDY/RxRdy interrupts
	rts

	


************ EASy68K trap routines *********************  
* Interrupt service for timer1, this is activated every 10ms
* update the wallclocks, decrement task's downtimer if it is not zero already
* 
timer1isr:
	add.l #1,wallclock
	add.l #1,$211004	* do the same with wallclock of other 3 tasks
	add.l #1,$212004
	add.l #1,$213004
	tst.w downtimer		* if downtimer is not zero, decrement it
	beq timer1isr1a
	sub.w #1,downtimer
timer1isr1a:
	tst.w $211008		* do the same with downtimer of other 3 tasks
	beq timer1isr1b
	sub.w #1,$211008
timer1isr1b:
	tst.w $212008
	beq timer1isr1bb
	sub.w #1,$212008
timer1isr1bb:
	tst.w $21200a		* needs 2 timer channels for xbee task
	beq timer1isr1c
	sub.w #1,$21200a
timer1isr1c:
	tst.w $213008
	beq timer1isr1d
	sub.w #1,$213008
timer1isr1d:
	move.b #$3,TER1		* clear event flag
	move.w #$200,ISR	* clear the timer1 in-service interrupt bit
	rte
*
* interrupt service for TxRdyA
* look at receive data first and process if needed and shut off background transmit
* then look at transmit data.  If in the middle of transmitting, keep on transmitting
* send next byte as pointed by a2.  When zero is encountered, shut off the transmitter
DUARTisr:
	movem.l d0-d4/a0-a2,-(sp)	* save
	btst.b #0,SRA+1		* look at receiver first
	beq chktx		* if no char received, check char to send
	move.w RHRA,d3		* get character
	tst.b cCmd		* if non zero, fill command buffer til CR
	bne getcmdline
	cmp.b #'R',d3
	beq dorwg
	cmp.b #'W',d3
	beq dorwg
	cmp.b #'G',d3
	beq dorwg
	cmp.b #'Z',d3
	beq doz
	cmp.b #'S',d3
	beq doSRload
getCmdline:
	cmp.b #$d,d3		* CR terminates the command line
	bne echo_rx		* if not CR, echo back the char entered in the command buffer
	move.b #1,fDoCmd	* make command ready to execute
	move.l pCmdln,a0
	cmp.b #' ',-1(a0)	* if trailing space, discard the space character
	beq gobackone
	bra edisr1
echo_rx:
	btst.b #2,SRA+1		* echo back 
	beq echo_rx
	cmp.b #8,d3		* backspace?
	beq echo_rubout
	move.b d3,THRA+1
	bra chkextrasp
*	cmp.b #8,d3		* backspace?
*	bne chkextrasp
echo_rubout
	move.b #$8,THRA+1	* try rubout character instead of 0x8, didn't work
	tst.b cCmd		* don't backspace past the first character
	beq what_no_CR		* try this approach, no perfect either
*	beq what		* is this better? confusion during mm session
*	beq edisr1		* debate about this approach
gobackone:
	sub.l #1,pCmdln		* backspace, go back one character
	sub.b #1,cCmd
	bra edisr1		* get next character
chkextrasp:
	move.l pCmdln,a0	* get pointer into command line buffer
	cmp.b #' ',d3		* if extra space, do not store
	bne fillcmdbuf
	cmp.b #' ',-1(a0)		* if previous is also space
	beq edisr1
fillcmdbuf
	move.b d3,(a0)
	add.l #1,pCmdln		* bump up one character	
	add.b #1,cCmd
	cmp.b #20,cCmd		* up to 20 characters. 
	bne edisr1
what:
*	move.l #qprompt,pStr	* send '?> ' 
	pea qprompt(pc)		* push error prompt pointer into stack
	move.l (sp)+,pStr	* pStr points to error prompt string
         bsr enableNextCmd          * initialize for new command
	bra txen
what_no_CR:
	pea q_no_cr(pc)		* put a single ? mark
	move.l (sp)+,pStr
         bsr enableNextCmd          * initialize for new command
	bra txen
dorwg:
	btst.b #2,SRA+1		* echo back character
	beq dorwg
	move.b d3,THRA+1	* echo back 'r' or 'w', 'g'
	clr.l d1		* d1 is the address pointer
	clr.l d4		* d4 is modified value for write command
	clr.b fWval		* existance of valid value for read/write cmd
* handle read/write the same, but the 2nd parameter has different meaning:
* for read, it indicates how many words to print
* for write, it indicates the modified value
* if 2nd parameter is not present, read the current address and write nothing
sp_1st:
	btst.b #0,SRA+1		* loop for the 1st space char after command
	beq sp_1st
	move.w RHRA,d0		
	cmp.b #' ',d0
	bne dorwg5		* valid inputs at this point are hex values
	bra echo_chr		* echo back
more_sp:
	tst.b fWval
	bne what		* if fWval already set and ' ' entered print ?>
	move.b #1,fWval		* mark write cmd with valid value
	bra echo_chr		* echo back
get_char:
	btst.b #0,SRA+1		* look for character
	beq get_char
	move.w RHRA,d0		* check for valid characters
	cmp.b #' ',d0
	beq more_sp		* space is separator for read/write
	cmp.b #$d,d0
	beq dorwg9		* CR also marks the end of command
dorwg5:
	move.b d0,d2		* save a copy
	bsr asc2hex
	cmp.b #$FF,d0		* valid hex?
	beq what		
	tst.b fWval		* r address or w data?
	bne dorwg6
	lsl.l #4,d1		* shift existing value one nibble to left
	add.b d0,d1		* append new address to existing one.
dorwg7:
	move.b d2,d0		* echo back	
echo_chr:
	btst.b #2,SRA+1
	beq echo_chr
	move.w d0,THRA		* echo back typed char
	bra get_char		* get more data
dorwg6:
	lsl.l #4,d4		* d4 contains the second parameter
	add.b d0,d4
	bra dorwg7
dorwg9:
	and.l #$00FFFFFE,d1	* make sure it is even address and 24-bit addr
	move.l d1,a0
	cmp.b #'W',d3
	beq dowrite
	cmp.b #'G',d3
	beq dorunrun
	tst.w d4		* if d4 equals 0, do one line of display memory
	beq dorwg8
	sub.w #1,d4		* for read cmd, print the number of words specified by d4
dorwg8:
	move.w (a0),d0		* read the specified memory location
	bsr compuAnswer		* forming the answer in buffer
	move.l #bAnswer,pStr	* send out the answer
	cmp.b #'W',d3		* if write cmd, print the memory content outside of ISR
	beq txen		* if read cmd, print number of words specified by d4
	tst.b fwval		* check valid 2nd parameter for read cmd
	beq txen		* if no 2nd parameter, print the memory content outside of ISR
	lea bAnswer,a2
	move.b #0,bAnswer+13	* modify the bAnswer message string so not to print prompt
dorwg8b:
	btst.b #2,SRA+1		* txRdy
	beq dorwg8b
	move.b (a2)+,d0
	beq dorwg8c
	move.b d0,THRA+1
	bra dorwg8b	
dorwg8c:
	add.l #2,a0		* next memory content, a0 contains the address value
	move.l a0,d1		* 
	dbra d4,dorwg8		* else print memory content d4 times within ISR
	move.b #$a,bAnswer+13	* replace the prompt back into bAnswer message string
	bra txprompt		* put out a prompt
dorunrun:
	clr.l d0		* status is passed back in d0
	jsr (a0)		* jump into whatever address user is entered
	tst.l d0
	bne what
txprompt:
*	move.l #prompt,pStr	* print the prompt
	lea prompt(pc),a0	* relocatable code
	move.l a0,pStr		* pStr points to prompt string
txen:
	move.w #3,IMRD		* enable tx/rx interrupts
	bra edisr1		
dowrite:
	tst.b fWval		* chk for valid write value
	beq dorwg8		* don't write if invalid
	move.w d4,(a0)		* write value out
	bra dorwg8		* read back value
* clear memory
doz:
	btst.b #2,SRA+1		* echo back
	beq doz
	move.w d3,THRA
doz1:
	btst.b #0,SRA+1		* read next char, must be $0d
	beq doz1
	move.w RHRA,d0
	cmp.b #$d,d0
	bne what
	bsr clrsavr
*	tst.b fwval
*	beq doz9
*	tst.l d1		* if 1st parameter is blank or zero do not clear mem
*	beq doz9
*	move.l d1,a5
*	bsr clrRAMa5
*doz9:
	lea zmemmsg(pc),a0
	move.l a0,pStr
	bra txen
*
* S record format as generated by qlink, ignore S0
* only echo back '.' per S record. send prompt if OK, send qprompt if error
* S1: byte count, 16 bit address, end with checksum 
* a0 is address, d1 is data, store value as they are received
* d2 is nibble count, d3 is srecord byte count, d4 is accumulated checksum
doSRload:
	move.w #$2700,sr	* mask off all interrupt so vector table can be
				* modified without crashing the code
	bra doload1
doload:
*	move.w #$2700,sr	* mask off all interrupt so vector table can be
				* modified without crashing the code
	btst.b #0,SRA+1		* look for another 'S'
	beq doload
	move.w RHRA,d0
	cmp.b #$d,d0		* put out '.' when CR encountered
	bne doload2
	tst.b fSerr		* if error, put out '?'
	beq doload3
	clr.b fSerr
	move.b #1,fSerrAll	* flag S record error in file load
	move.b #'?',THRA+1
	bra doload2
doload3:
	move.b #'.',THRA+1
doload2:
	cmp.b #'S',d0
	bne doload
doload1:
	btst.b #0,SRA+1		* look for S1 or exit with ?>
	beq doload1
	move.w RHRA,d0
	cmp.b #'0',d0
	beq doload
	cmp.b #'1',d0
	beq doS1
	cmp.b #'2',d0
	beq doS2
	cmp.b #'8',d0		* S8 record?
	beq doS8
	cmp.b #'9',d0		* S9 record?
	beq doS9
	not.b fSerr		* mark the line as error
	bra doload

doS8:
* if the address field is 0, or there are checksum error, exit
* if the address field is non zero, and no checksum error, jump to the specified address
* There are only 4 bytes: 3-byte address and checksum 
	clr.l d4		* prepare checksum
	move.w #1,d2		* get Srecord byte count
	bsr char2hex
	add.b d1,d4		* accumulate checksum
	cmp.b #4,d1		* should have a length of 4 exactly
	bne doS8x
	move.w #5,d2		* get 3-byte starting address
	bsr char2hex
	add.b d1,d4		* accumulate checksum, low address
	ror.l #8,d1
	add.b d1,d4		* accumulate checksum, mid address
	ror.l #8,d1
	add.b d1,d4		* accumulate checksum, high address
	ror.l #8,d1
	ror.l #8,d1		* restore original value
	move.l d1,startaddr	* save the start address
	not.b d4		* checksum expected next
	move.w #1,d2
	bsr char2hex
	cmp.b d1,d4		* compare calculated checksum
	bne doS8x
	tst.b fSerrAll		* check for total error count
	bne doS8x
	bsr wCRquitX		* wait for CR and mark end of SR load before continuing
	tst.l startaddr		* If starting address is 0, return to prompt
	beq doS8w
	lea runSrecord(pc),a0	* notify S record is loaded and running
	bsr TxStringA0		* not using interrupt service to put out string	
	move.l startaddr,savpc	* put the start address in savpc for 'go' command to act on
	move.w #'go',bCmdline
	move.b #2,cCmd		* there are 2 characters in the command buffer
	clr.b cCmdparam		* no parameter, so use the value of savpc for 'go' command
	move.b #1,fDoCmd		* ready 'go' command execution
* delay 0.1 second before jump into application
	move.l #$77000,d6	* diagnostic
w2abit:
	sub.l #1,d6		* diagnostic
	bne w2abit		* diagnostic
	bra txen
	
	* move.l startaddr,a1	* else jump into the start address
	* jsr (a1)			
	* lea rundoneSR(pc),a0	* notify that s record execution completed
	* bsr TxStringA0	
* doS8y:	
	* lea prompt(pc),a0	* relocatable code
	* move.l a0,pStr		* pStr points to prompt string
	* bra txen
doS8w:
	lea validSrecord(pc),a0	* output valid s record received message
	move.l a0,pStr
	bra txen
doS8x:
	bsr wCRquitX		* wait for CR and exit SR loader
	pea qprompt(pc)
	move.l (sp)+,pStr
	clr.b fSerrAll
	bra txen	
doS9:
* if the address field is 0, or there are checksum error, exit
* if the address field is non zero, and no checksum error, jump to the specified address
* There are only 3 bytes: 2-byte address and checksum 
	clr.l d4		* prepare checksum
	move.w #1,d2		* get Srecord byte count
	bsr char2hex
	add.b d1,d4		* accumulate checksum
	cmp.b #3,d1		* should have a length of 3 exactly
	bne doS9x
	move.w #3,d2		* get 2-byte starting address
	bsr char2hex
	add.b d1,d4		* accumulate checksum, lower address
	ror.w #8,d1
	add.b d1,d4		* accumulate checksum, higher address
	ror.w #8,d1		* restore original value
	move.l d1,startaddr	* save the start address
	not.b d4		* checksum expected next
	move.w #1,d2
	bsr char2hex
	cmp.b d1,d4		* compare calculated checksum
	bne doS9x
	tst.b fSerrAll		* check for total error count
	bne doS9x
	bsr wCRquitX		* wait for CR and mark end of SR load before continuing
	tst.l startaddr		* If starting address is 0, return to prompt
	beq doS9w
	lea runSrecord(pc),a0	* notify S record is loaded and running
	bsr TxStringA0		* not using interrupt service to put out string	
	move.l startaddr,savpc	* put the start address in savpc for 'go' command to act on
	move.w #'go',bCmdline
	move.b #2,cCmd		* there are 2 characters in the command buffer
	clr.b cCmdparam		* no parameter, so use the value of savpc for 'go' command
	move.b #1,fDoCmd		* ready 'go' command execution

* delay 0.1 second before jump into application
	move.l #$77000,d6	* diagnostic
w1abit:
	sub.l #1,d6		* diagnostic
	bne w1abit		* diagnostic
	bra txen
	
	* move.l startaddr,a1	* else jump into the start address
	* jsr (a1)			
	* lea rundoneSR(pc),a0	* notify that s record execution completed
	* bsr TxStringA0
* doS9y:	
	* lea prompt(pc),a0	* relocatable code
	* move.l a0,pStr		* pStr points to prompt string
	* bra txen
doS9w:
	lea validSrecord(pc),a0	* output valid s record received message
	move.l a0,pStr
	bra txen
doS9x:
	bsr wCRquitX		* wait for CR and exit SR loader
	pea qprompt(pc)
	move.l (sp)+,pStr
	clr.b fSerrAll
	bra txen
doS1:
	clr.l d4
	move.w #1,d2		* get Srecord byte count
	bsr char2hex
	add.b d1,d4		* accumulate checksum
	move.w d1,d3
	sub.w #4,d3		* don't count CRC byte nor 2-byte address		
	move.w #3,d2		* get 2-byte starting address
	bsr char2hex
	add.b d1,d4		* accumulate checksum, lower address
	ror.w #8,d1		
	add.b d1,d4		* accumulate checksum, higher address
	ror.w #8,d1		* restore
	move.l d1,a0
srdata:
	move.w #1,d2		* get byte data
	bsr char2hex
	add.b d1,d4		* accumulate checksum
	move.b d1,(a0)		* store value to destination
	cmp.b (a0)+,d1		* write verify
	beq srdatax
	move.b #1,fSerr
srdatax:	
	dbra d3,srdata
	not.b d4		* checksum expected
	move.w #1,d2
	bsr char2hex
	cmp.b d1,d4
	beq doload
	move.b #1,fSerr		* send out a question mark
	bra doload
doS2:
	clr.l d4
	move.W #1,d2		* get Srecord byte count
	bsr char2hex
	add.b d1,d4		* accumulate checksum
	move.W d1,d3
	sub.W #5,d3		* don't count CRC byte nor 3-byte address		
	move.W #5,d2		* get 3-byte starting address
	bsr char2hex
	add.b d1,d4		* accumulate checksum, lower address
	ror.l #8,d1		
	add.b d1,d4		* accumulate checksum, middle address
	ror.l #8,d1		* 
	add.b d1,d4		* accumulate checksum, upper address
	ror.l #8,d1
	ror.l #8,d1		* restore
	move.l d1,a0
srdata2:
	move.w #1,d2		* get byte data
	bsr char2hex
	add.b d1,d4		* accumulate checksum
	move.b d1,(a0)		* store value to destination
	cmp.b (a0)+,d1		* write verify
	beq srdata2x
	move.b #1,fSerr		* flag if not able to write
srdata2x:
	dbra d3,srdata2
	not.b d4		* checksum expected
	move.w #1,d2
	bsr char2hex
	cmp.b d1,d4
	beq doload
	move.b #1,fSerr		* send out a question mark
	bra doload	
chktx:
	btst.b #2,SRA+1		* look for transmit ready
	beq edisr1		* nothing, exit
	move.l pStr,a0		* load the string pointer
	move.b (a0),d0
	bne txNxtChar              * if end of string, check if need to append CR/LF
chkfCRLF:
* null terminator reached, check if need to append CR/LF
         tst.b fEASyTCRLF           * if flag set, add append CR LF to message
         beq edisr                  * no CR LF, transmission completed
	move.b #$d,THRA+1         * send out CR
w2sendLF:
	btst.b #2,SRA+1            * wait until transmit ready to send LF
	beq w2sendLF
	move.b #$a,THRA+1          * send out LF
	bra edisr
txNxtChar:
	move.b d0,THRA+1	* put out the next byte as pointed by a0
	add.l #1,pStr		* update the string pointer
	bra edisr1	
edisr:
	move.w #2,IMRD		* mask off transmit interrupts
	move.b #True,fTxDone	* flag transmission of string finished
edisr1:
	move.w #2,ISR		* clear in-service bit associated with DUART
	movem.l (sp)+,d0-d4/a0-a2	* restore
	rte
* 
* subroutine wait for CR then quit with 'X' output
wCRquitX:
	btst.b #0,SRA+1		* look for CR and quit
	beq wCRquitX
	move.w RHRA,d0
	cmp.b #$d,d0
	bne wCRquitX
	move.b #'X',THRA+1
wCRquitX1:
	btst.b #2,SRA+1		* look for transmit done before returning
	beq wCRquitX1
	rts
*
* subroutine to get prescribed number of characters in d2, convert to hex and put in
* d1 
char2hex:
	clr.l d1		* important to clear all d1 when start
c2h1:
	btst.b #0,SRA+1
	beq c2h1
	move.w RHRA,d0
	bsr asc2hex
	cmp.b #$FF,d0
	bne c2h1_1
	move.b #1,fSerr		* mark this as an error and go on
c2h1_1:
	lsl.l #4,d1		
	add.b d0,d1		* append to existing value
	dbra d2,c2h1
	rts
*
* Bus error handling
* print "Bus error" in polling mode and return
buserr:
	add.w #$1000,cUErr
	movem.l d0-d7/a0-a7,savd0	* save away registers
	move.l $A(sp),savpc

	lea berrmsg(pc),a0
	bsr TxStringA0
	move.l 2(sp),d0		* print the access address
	bsr TxRegD0
	lea pcmsg(pc),a0	* print PC value
	bsr TxStringA0
	move.l $a(sp),d0
	bsr TxRegD0
	bra unknown		* blink lights forever

	nop			* extra pad
	nop

	include "lcd4x20A.x68"	* LCD display task

*	include "Xbee.x68"	* Xbee task

* uncomment the include to program AMbug into boot flash.
*	include prog010b.a68
	include "p29f040.x68"
* that's all folks!

	end restart
*	end $0            * don't auto start






















*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~9~
